/* Copyright (c) 2011 Asustor Inc. All rights reserved. */

Ext.define('AS.ARC.apps.takeasy.core.TESavelocation', {
	extend: 'Ext.form.field.Text',

	alias: ['widget.asTESavelocation'],

	readOnly: true,

	labelWidth: AS.ARC.config.layout.defaultLabelWidth,

	allowBlank: false,

	blankText: _S('MESSAGE', 'HF00011'),

	value: '/Download',

	getPath: function () {
		var me = this;
		return me.getValue();
	},

	initComponent: function () {
		var me = this;

		me.callParent(arguments);

	},

	beforeDestroy: function () {
		var me = this;

		me.callParent(arguments);
	}
});

/**
 * @class AS.ARC.apps.takeasy.core.notification
 * @extends Ext.container.Container
 * <p></p>
 */
Ext.define('AS.ARC.apps.takeasy.core.TENotification', {
	extend: 'Ext.container.Container',

	alias: ['widget.asTENotification'],

	cls: 'te-counter',

	setValue: function (value) {
		if (!Ext.isNumber(value)) return;
		var me = this;
		me.el.dom.innerHTML = value;
	},

	initComponent: function () {
		var me = this;

		me.callParent(arguments);

	},

	beforeDestroy: function () {
		var me = this;

		me.callParent(arguments);
	}
});

/**
 * @class AS.ARC.apps.takeasy.core.sideButton
 * @extends Ext.button.Button
 * <p></p>
 */
Ext.define('AS.ARC.apps.takeasy.core.sideButton', {
	extend: 'Ext.button.Button',

	alias: ['widget.asTESideBtn'],
	width: 200,

	displayCount: true,
	counterCls: 'te-counter-normal',

	initComponent: function () {
		var me = this;

		me.callParent(arguments);

		me.on('afterrender', me.handleafterrender);

		me.on('mouseover', me.handlemouseover);

		me.on('mouseout', me.handlemouseout);

		me.on('toggle', me.handletoggle);
	},

	beforeDestroy: function () {
		var me = this;

		me.un('mouseover', me.handleafterrender);

		me.un('mouseover', me.handlemouseover);

		me.un('mouseout', me.handlemouseout);

		me.un('toggle', me.handletoggle);

		me.callParent(arguments);
	},

	setCount: function (num) {
		var me = this;
		if (num > 999) num = '999+';
		me.counter.el.dom.innerHTML = num;
	},

	handleafterrender: function () {
		var me = this;

		if (me.displayCount) {
			me.counter = Ext.create('AS.ARC.apps.takeasy.core.TENotification', {
				html: '0',
				renderTo: me.id
			});
			me.counter.addCls(me.counterCls);
		}
	},

	handlemouseover: function () {
		var me = this;
		//me.setIcon(me.iconOver);
		if (me.pressed) return;
		me.btnIconEl.dom.style.cssText = 'background-image: url(' + me.icon + '); background-position: 0px 0px;';
	},

	handlemouseout: function () {
		var me = this;		
		if (me.pressed) return;
		//me.setIcon(me.iconNormal);
		me.btnIconEl.dom.style.cssText = 'background-image: url(' + me.icon + '); background-position: 0px 0px;';
	},

	handletoggle: function (me, pressed) {
		var me = this;

		var panelVedio = document.getElementsByClassName('takeasy-video')[0];
		var panelSubscription = document.getElementsByClassName('takeasy-subscription')[0];
		try {
			Ps.destroy(panelVedio);
			Ps.destroy(panelSubscription);
		} catch (e) {
			console.log(e);
		}
		

		if (pressed) {
			//me.handlemouseover(me);
			me.btnIconEl.dom.style.cssText = 'background-image: url(' + me.icon + '); background-position: -24px 0px;';
		} else {
			//me.handlemouseout(me);
			me.btnIconEl.dom.style.cssText = 'background-image: url(' + me.icon + '); background-position: 0px 0px;';
		}
	}
});

/**
 * @class AS.ARC.apps.takeasy.core.TEButton
 * @extends Ext.container.Container
 * <p></p>
 */
Ext.define('AS.ARC.apps.takeasy.core.TEButton', {
	extend: 'Ext.container.Container',

	alias: ['widget.asTEButton'],	

	width: 24,
	height: 24,
	style: 'background-position:0px; 0px; cursor:pointer;',
	maskOnDisable: false,

	icon: {
		normal: '',
		over: '',
		pressed: ''
	},

	tooltip: '',

	handler: Ext.emptyFn,

	initComponent: function () {
		var me = this;

		me.callParent(arguments);

		me.addEvents('mouseover', 'mouseout', 'mousedown', 'mouseup', 'click');

		me.on('afterrender', me.handleafterrender);
		
		me.on('mouseover', me.handlemouseover);

		me.on('mouseout', me.handlemouseout);

		me.on('mousedown', me.handlemousedown);

		me.on('mouseup', me.handlemousup);

		me.on('click', me.doHandler, me);

		me.on('disable', me.handledisable);
	},

	beforeDestroy: function () {
		var me = this;

		me.un('afterrender', me.handleafterrender);

		me.un('mouseover', me.handlemouseover);

		me.un('mouseout', me.handlemouseout);

		me.un('mousedown', me.handlemousedown);

		me.un('mouseup', me.handlemousup);

		me.un('click', me.doHandler);

		me.un('disable', me.handledisable);

		Ext.fly(me.el).un('mouseover');

		Ext.fly(me.el).un('mouseout');

		Ext.fly(me.el).un('mousedown');

		Ext.fly(me.el).un('mouseup');

		Ext.fly(me.el).un('click');

		me.callParent(arguments);
	},

	setIcon: function (icon) {
		var me = this;
		me.el.dom.style.backgroundImage = 'url(' + icon + ')';
	},

	setTip: function (text) {
		var me = this;
		if (text === '') return;
		me.el.dom.setAttribute('data-qtip', text)
	},

	doHandler: function (me) {
		if (me.disabled) return;
		me.handler(me);
	},

	handlemouseover: function (me) {
		if (me.disabled) {
			me.el.dom.style.cursor = 'default';
			return;
		}
		me.el.dom.style.backgroundPosition = '-24px 0px';
		//me.el.dom.style.cursor = 'pointer';
		//me.setIcon(me.icon.over);
	},

	handlemouseout: function (me) {
		if (me.disabled) return;
		//me.setIcon(me.icon.normal);
		me.el.dom.style.backgroundPosition = '0px 0px';
	},

	handlemousedown: function (me) {
		if (me.disabled) return;
		//me.setIcon(me.icon.pressed);
		me.el.dom.style.backgroundPosition = '-48px 0px';
	},

	handlemousup: function (me) {
		if (me.disabled) return;
		//me.setIcon(me.icon.over);
		me.el.dom.style.backgroundPosition = '-24px 0px';
	},

	handleafterrender: function () {
		var me = this;

		me.setIcon(me.icon.normal);
		me.setTip(me.tooltip);

		Ext.fly(me.el).on('mouseover', function () {
			me.fireEvent('mouseover', me);
		});

		Ext.fly(me.el).on('mouseout', function () {
			me.fireEvent('mouseout', me);
		});

		Ext.fly(me.el).on('mousedown', function () {
			me.fireEvent('mousedown', me);
		});

		Ext.fly(me.el).on('mouseup', function () {
			me.fireEvent('mouseup', me);
		});

		Ext.fly(me.el).on('click', function () {
			me.fireEvent('click', me);
		});
	},

	handledisable: function () {
		var me = this;
		me.setIcon(me.icon.normal);
	}
});

Ext.define('AS.ARC.apps.takeasy.core.TETreeSelector', {
	extend: 'AS.ARC.treeSelector',

	hideReadOnly: true,
	PATH_USER_HOME: '/User Homes',
	unselectableFolder: ['/User Homes'],

	createTreeNodes: function(rootNode) {
		var fs = this;
		rootNode.removeAll();
		//create all share_folders treeNodes use ajax
		var urlOpts = {
			act: 'file_list',
			path: 'share_folders'
		};

		if (fs.isShowHome)
			Ext.apply(urlOpts, { showhome: true });

		fs.locationTree.body.mask(_S('COMMON', 'LOADING'));
		AS.ARC.ajax({
			url: AS.ARC.util.getApiUrlWithSid(fs.FEUrl, urlOpts),
			method: 'post',
			success: function(json, opts) {
				fs.locationTree.body.unmask();
				var datas = json.data;
				if (datas.length === 0) {
					var noFolderWin = Ext.create('AS.ARC.msgWindow', {
						title: _S('COMMON', 'INFORMATION'),
						parentWin: fs.win,
						height: 200,
						iconType: 'info', // info, question, warning
						asItems: [{
							xtype: 'displayfield',
							value: _S('ERROR', 'NO_ACCESS_RIGHT_SHARE_FOLDERS')
						}],
						fbar: [{
							text: _S('COMMON', 'OK'),
							handler: function() { noFolderWin.close(); }
						}]
					}).show();
				}
				for (var i = 0; i < datas.length; i++) {
					var myarchiveFormat = '/volume1/MyArchive',
						// path = datas[i].phy_path;
						path = datas[i].physical_path,
						isUserHomes = datas[i].file_path === fs.PATH_USER_HOME;
					var isMyArchive = function() {
						array = path.split(myarchiveFormat);
						if (array.length === 2) {
							if ((array[1] !== '') && (array[1] <= AS.ARC.config.bay - 1)) {
								return true;
							} else {
								return false;
							}
						} else {
							return false;
						}
					};
					if (fs.disableMyArchive && isMyArchive()) {
						continue;
					} else if (isUserHomes && AS.ARC.user.account !== 'admin') {
						continue;
					}

					if (fs.onlyShowHome) {
						if (path.indexOf('/home/') === -1) {
							continue;
						}
					}

					if (!fs.hideReadOnly || !fs.isReadOnly(datas[i].access_permission)) {
						if (datas[i].share_folder_type != fs.SHARE_FOLDERS_TYPE_MOUNT) {
							var nodeConfig = {
								text: Ext.htmlEncode(datas[i].filename),
								leaf: false,
								id: datas[i].file_path,
								type: datas[i].share_folder_type,
								phy_path: datas[i].physical_path,
								qtip: Ext.htmlEncode(Ext.htmlEncode(datas[i].filename))
							}
						} else {
							var nodeConfig = {
								text: Ext.htmlEncode(datas[i].filename),
								leaf: false,
								id: datas[i].file_path,
								type: datas[i].share_folder_type,
								phy_path: datas[i].physical_path,
								qtip: Ext.htmlEncode(Ext.htmlEncode(datas[i].filename)),
								icon: AS.ARC.util.fixDc('apps/fileExplorer/images/files_list/iso.png'),
							}
						}
						rootNode.appendChild(nodeConfig);
					}
				}
				setTimeout(function() {
					var panelBody = fs.win.el.dom.querySelectorAll('.x-panel-body')[2];
					Ps.update(panelBody);
					fs.btnRefresh.enable();
				}, 200);
			},
			failure: function(json, opts) {
				fs.btnRefresh.enable();
				AS.ARC.util.msgDialog(fs.win, fs.MSG_TYPE_ERROR, json.error_msg);
			}
		});
	},
});

/**
 * @class AS.ARC.apps.takeasy.core
 * @extends Ext.util.Observable
 * <p>core</p>
 */
Ext.define('AS.ARC.apps.takeasy.core', {
	extend: 'Ext.util.Observable',
	
	apiUrl: AS.ARC.util.getUserAppsPath() + 'takeasy/video_downloader.cgi',
	imageUrl: AS.ARC.util.getUserAppsPath() + 'takeasy/images/',	

	did: '',
	location: '',

	constructor: function (config) {
		Ext.apply(this, config);
		
		this.callParent();	
		
		this.init(config);
	},
	
	getTimeInfo: function (seconds) {
		var mins = Math.floor(seconds / 60),
			secs = Math.ceil(seconds % 60);

		if (secs == 60) {
			secs = 0;
			mins++;
		}

		mins = mins.toString();
		secs = secs.toString();

		if (mins.length === 1) {
			mins = '0' + mins;
		}

		if (secs.length === 1) {
			secs = '0' + secs;
		}
		return mins + ':' + secs;
	},

	renderInsufficient: function () {
		var fn = this,
			topItems = fn.mainPanel.items.get('topbar').items;

		if (fn.location === '') {
			fn.mainPanel.items.get('content').el.mask(_S('TAKEASY', 'SEL_DEST_FOLDER'), 'as-mask-msg');
			fn.mainPanel.items.get('sidebar').el.mask();
			
			topItems.get('add').disable();
			topItems.get('pause').disable();
			topItems.get('resume').disable();
			topItems.get('clear').disable();
		} else {
			fn.mainPanel.items.get('content').el.unmask();
			fn.mainPanel.items.get('sidebar').el.unmask();

			topItems.get('add').enable();
		}
	},

	init: function () {
		var fn = this;				
		
		this.win = fn.desktop.createWindow({
			app: fn.app,
			itemId: 'app-takeasy',
			id: fn.id,
			//itemId: fn.id,
			width: 880,
			height: 582,
			resizable: true,
			maximizable: true,
			// minWidth: 880,
			// minHeight: 582,
			border: false,
			layout: 'fit',
			items: [
				fn.getMainPanel()
			],
			loadSetting: function () {
				var me = this;
				AS.ARC.ajax({
					url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, { act: 'get_general_option' }),
					method: 'post',
					win: fn.win,
					success: function (json, opts) {												
						if (json.location === '') {
							fn.location = '';
						} else {
							// fn.location = decodeURIComponent(json.location).split('/volume1')[1];
							fn.location = json.location;
						}
						fn.renderInsufficient();
					},
					failure: function (json, opts) {

						AS.ARC.util.showMsgWindow({
							//5039: _S('TAKEASY', 'UNABLE_FIND_VIDEO')
						}, json, fn.win);
					}
				});
			},
			listeners: {
				afterrender: function (win) {
					win.header.items.items[1].hide();
					win.loadSetting();
					win.takeasy = AS.ARC.events.takeasy;
					win.takeasy_sub = AS.ARC.events.takeasy_sub;

					win.eventId = setInterval(function () {
						var content = win.items.get('main').items.get('content'),
							videoPanel = content.items.get('video-ct').items.get('video-panel'),
							subscriptPanel = content.down('#subscript-panel');

						if (win.takeasy != AS.ARC.events.takeasy) {							
							videoPanel.realStore.isMask = false;
							videoPanel.realStore.load();
							win.takeasy = AS.ARC.events.takeasy;
						}
						if (win.takeasy_sub != AS.ARC.events.takeasy_sub) {
							if (subscriptPanel.store.getCount() < 25) {
								var panel = document.getElementsByClassName('takeasy-subscription')[0];
								try {
									Ps.destroy(panel);
								} catch (e) {
									console.log(e);
								}
								subscriptPanel.store.removeAll();
								fn.loadSubscriptionAccount();
							}
							win.takeasy_sub = AS.ARC.events.takeasy_sub;
						}
					}, 5000);
				},
				beforeclose: function (me) {
					clearTimeout(fn.dId);
					clearTimeout(me.eventId);
				},
				resize: function () {
					fn.mainPanel.items.get('content').items.get('video-ct').items.get('paging').doLayout();
				},
				maximize: function(win, eOpts) {
					win.resizer.disable();
				},
				restore: function(win, eOpts) {
					win.resizer.enable();
				}
			}
		});
	},

	getMainPanel: function () {
		var fn = this;
		
		this.mainPanel = Ext.create(Ext.panel.Panel, {
			itemId: 'main',
			layout: 'border',
			cls: 'app-te',
			items: [
				fn.getTopbarPanel(),
				fn.getContentPanel(),
				fn.getSidebarPanel()
			],
			listeners: {
				afterrender: function (me) {
					var videoPanel = me.items.get('content').items.get('video-ct').items.get('video-panel');
					Ext.defer(function () {
						videoPanel.realStore.isMask = true;
						videoPanel.realStore.load();						
					}, 200);
					me.items.get('sidebar').items.get('download').toggle(true);
					me.items.get('sidebar').items.get('download').renderTopbar();
				},
				tabchange: function (tabpanel, newPanel, oldPanel) {

				}
			}
		});
		return fn.mainPanel;
	},	

	getSidebarState: function () {		
		var targetIdx,
			fn = this;
		//searchBar = topbar.items.get('search-ct').items.get('search');

		Ext.ComponentQuery.query('button', fn.mainPanel.items.get('sidebar')).forEach(function (item, index) {
			if (item.pressed) {
				targetIdx = index;
				return false;
			}
		});

		//var type = '';

		//switch (targetIdx) {
		//	case 0:
		//		type = 1; //download
		//		break;
		//	case 1:
		//		type = 3; //complete
		//		break;
		//	case 2:
		//		type = 4; //fail
		//		break;
		//	case 3:
		//		type = 'subscript';
		//		break;
		//	default:
		//		break;
		//}

		//return type;
		return targetIdx;
	},

	getContentPanel: function () {
		var fn = this;		
		
		var videoStore = Ext.create(Ext.data.Store, {
			pageSize: 50,
			//pageSize: 6,	// for debug	
			isMask: true,
			autoLoad: false,
			fields: ['cid', 'url', 'location', 'thumbnail', 'title', 'provider', 'duration', 'format',
			'size', 'state', 'progress', 'video_path', 'video_exist', 'is_folder'],
			proxy: {
				type: 'ajax',
				url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, { act: 'list_download' }),
				extraParams: {
					list_type: 0
				},
				timeout: 120000,
				actionMethods: {
					create: 'POST',
					read: 'POST',
					update: 'POST',
					destroy: 'POST'
				},
				reader: {
					type: 'json',
					root: 'items'
				}
			},
			listeners: {
				beforeload: function () {
					var state = fn.getSidebarState();
					videoStore.proxy.extraParams.list_type = (state === 3) ? 1 : state;
					if (fn.getSidebarState() !== 3 && videoStore.isMask){
						if (fn.mainPanel.el.dom.getDimensions().height > 0) {
							fn.mainPanel.el.mask(_S('COMMON', 'LOADING'));
						}
					}
				},
				load: function (me, records) {
					var sidebarPanel = fn.mainPanel.items.get('sidebar'),
						json = me.proxy.reader.jsonData,
						//summary = json.summary,
						state = fn.getSidebarState(),
						isUpdating = json.download !== 0;

					sidebarPanel.updateCounter({
						download: json.download,
						finish: json.finish,
						failed: json.failed
					});

					
					if (state === 3) {
						me.each(function (r) {
							if (r.data.state === 3) {
								var findIdx = subscriptPanel.store.find('url', r.data.url);
								if (findIdx !== -1) {
									if (subscriptPanel.store.getAt(findIdx).data.state !== r.data.state) {
										subscriptPanel.store.getAt(findIdx).set('state', r.data.state);
										subscriptPanel.store.getAt(findIdx).set('cid', r.data.cid);
									}
								}
							}
						
						});
					} 
					if (isUpdating) {
						me.isMask = false;
						fn.mainPanel.el.unmask();
						clearTimeout(fn.dId);
						fn.dId = Ext.defer(function () {
							//var pageState = fn.getSidebarState();
							//if (pageState === 3) pageState = 1;
							//me.proxy.extraParams.list_type = pageState;
							me.load();
						}, 5000);
					} else {
						me.isMask = true;
						clearTimeout(fn.dId);
					}

					if (state === 3) return;

					var topItems = fn.mainPanel.items.get('topbar').items;					
					if (me.getCount() !== 0) {
						topItems.get('resume').enable();
						topItems.get('pause').enable();
						topItems.get('clear').enable();
					} else {
						topItems.get('resume').disable();
						topItems.get('pause').disable();
						topItems.get('clear').disable();
					}
					
					if (videoFilterStore.getCount() === 0) { //no content inside
						videoFilterStore.add(me.data.items);
					}

					if (me.getCount() === 0) {
						videoFilterStore.removeAll();
					}

					//delay for el render
					Ext.defer(function () {
						Ext.each(me.data.items, function (item, idx) {
							var ct = videoPanel.el.query('div.videoItem-' + item.data.cid + ' > div.center > div.meta > div.row-two'),
								imgCt = videoPanel.el.query('div.videoItem-' + item.data.cid + ' > div.left > img'),
								infosCt = videoPanel.el.query('div.videoItem-' + item.data.cid + ' > div.center > div.meta > div.row-one')[0];
							if (ct.length !== 0) {
								var progressCt = ct[0],
									progress = progressCt.querySelector('div.progress'),
									progressText = progressCt.querySelector('div.progress-text'),
									percent = item.data.progress + '%',
									infos = infosCt.querySelectorAll('div.item'),
									title = videoPanel.el.query('div.videoItem-' + item.data.cid + ' > div.center > div.title')[0],
									thumb = imgCt[0];

								if (item.data.thumbnail === '') {
									thumb.src = fn.imageUrl + 'default_thumb.png';
								} else {
									thumb.src = Ext.String.htmlDecode(item.data.thumbnail);
								}
								//workaround
								if (item.data.title === '') {
									title.innerHTML = (item.data.state === 4) ? _S('TAKEASY', 'VIDEO_UNAVAILABLE') : 'Video Title';
								} else {
									title.innerHTML = Ext.String.htmlEncode(item.data.title);
								}
								infos[0].innerHTML = (item.data.provider === '') ? 'Provider' : item.data.provider;
								infos[1].innerHTML = (item.data.duration === 0) ? '--:--' : fn.getTimeInfo(item.data.duration);
								var format = item.data.format;
								if (format === '') {
									format = '--';
								} else if (format !== 'flv') {
									var dimension = item.data.format.split(' - ')[1].split(' (')[0];
									if (dimension.indexOf('x') !== -1) {
										var dimSplit = dimension.split('x');
										if (parseInt(dimSplit[0]) < parseInt(dimSplit[1])) {
											dimension = dimSplit[0] + 'p';
										} else {
											dimension = dimSplit[1] + 'p';
										}
									}
									format = dimension;
								}
								infos[2].innerHTML = format;
								infos[3].innerHTML = (item.data.size === 0) ? '--' : AS.ARC.util.convertSizeUnit(item.data.size);

								if (typeof progress !== 'undefined') {
									progress.style.width = percent;
									progressText.innerHTML = percent;
								}
							}

							var filterMax = videoFilterStore.getCount() - 1;

							if (idx > filterMax) { //exceed user data length
								videoFilterStore.insert(idx, item);
							} else {
								var r = videoFilterStore.getAt(idx);
								if (r.data.cid !== item.data.cid) {
									videoFilterStore.removeAt(idx);
									videoFilterStore.insert(idx, item);
								}

								r = [];
								if (idx === me.data.items.length - 1 && idx < filterMax) { //below user data length
									for (var i = idx + 1; i <= filterMax; i++) {
										r.push(videoFilterStore.getAt(i));
									}
									videoFilterStore.remove(r);
								}
							}
							
						});
						
						var panel = document.getElementsByClassName('takeasy-video')[0];
						// 6 筆 video record(就需要 scrollbar)
						if (panel.childNodes.length < 6 ){
							Ps.destroy(panel);
						} else {				
							Ps.destroy(panel);
							Ps.initialize(panel, {
								suppressScrollX: true
							});
							Ps.update(panel);

							setTimeout(function() {	
								Ps.update(panel);
							}, 200);				
						}	

					}, 200);
					//if (getSidebarState() !== 'subscript')
					if (fn.getSidebarState() !== 3 && videoStore.isMask) {
						Ext.defer(function () {
							fn.mainPanel.el.unmask();
						}, 300);
					}


					var panel = document.getElementsByClassName('takeasy-video')[0];
					// 6 筆 video record(就需要 scrollbar)
					if (panel.childNodes.length < 6 ){
						Ps.destroy(panel);
					} else {				
						Ps.destroy(panel);
						Ps.initialize(panel, {
							suppressScrollX: true
						});
						Ps.update(panel);

						setTimeout(function() {	
							Ps.update(panel);
						}, 200);				
					}
				}
			}
		});

		var videoFilterStore = Ext.create(Ext.data.Store, {
			//pageSize: 10,
			autoLoad: false,
			fields: ['cid', 'url', 'location', 'thumbnail', 'title', 'provider', 'duration', 'format',
			'size', 'state', 'progress'],
			listeners: {
				add: function (me, record) {
					Ext.defer(function () {
						Ext.each(record, function (r) {
							videoPanel.getCustomCmp(r);
						});
					}, 10);
				}
			}
		});

		var videoXTpl = new Ext.XTemplate(
			'<tpl for=".">',				
				'<div class="videoItem videoItem-{cid} as-expandable-grid-row as-expandable-grid-row-outer-ct">',
					//left
					'<div class="left"></div>',
					//center
					'<div class="center">',
						'<div class="title" data-qtip="{[Ext.String.htmlEncode(this.getTitle(values.title, values.state))]}">{[this.getTitle(values.title, values.state)]}</div>',
						'<div class="meta">',
							'<div class="row-one">',
								'<div class="item" style="width:55px;">{[this.getProvider(values.provider)]}</div>',
								'<div class="item" style="width:40px;float:left;">{[this.getDuration(values.duration)]}</div>',
								'<div class="item" style="width:70px;float:left;">{[this.getRes(values.format)]}</div>',
								'<div class="item" style="width:100px;float:left;">{[this.getFileSize(values.size)]}</div>',
							'</div>',
							'<tpl if="this.isProgress(state)">',
								'<div class="row-two">',
									'<div style="width:100%;padding:3px 0px 0px 0px;">',
										'<div style="float:left;width:85%;">',
											'<div style="background-color:#d8d7e3;height:8px;padding:1px;"><div class="progress" style="width:{progress}%;"></div></div>',
										'</div>',
										'<div style="float:left;width:15%;text-align:center;margin-top:-6px;padding-left:10px;">',
											'<div class="progress-text">{progress}%</div>',
										'</div>',
									'</div>',
								'</div>',
							'</tpl>',
						'</div>',
					'</div>',
					//right
					'<div class="right">',
						//'<div class="btn-group"></div>',
					'</div>',
				'</div>',
			'</tpl>',
			'<div class="x-clear"></div>',
			{
				getTitle: function (value, state) {
					if (value === '') {
						return (state === 4) ? _S('TAKEASY', 'VIDEO_UNAVAILABLE') : 'Video Title';
					} else {
						return Ext.String.htmlEncode(value);
					}
				},
				getProvider: function (value) {
					return (value === '') ? 'Provider' : value;
				},
				getDuration: function (value) {
					return (value === 0) ? '--:--' : fn.getTimeInfo(value);
				},
				getRes: function (value) {
					if (value === '') {
						return '--';
					} else if (value !== 'flv') {
						var dimension = value.split(' - ')[1].split(' (')[0];
						if (dimension.indexOf('x') !== -1) {
							var dimSplit = dimension.split('x');
							if (parseInt(dimSplit[0]) < parseInt(dimSplit[1])) {
								dimension = dimSplit[0] + 'p';
							} else {
								dimension = dimSplit[1] + 'p';
							}
						}
						return dimension;
					} else {
						return value;
					}
				},
				getFileSize: function (value) {
					return (value === 0) ? '--' : AS.ARC.util.convertSizeUnit(value);
				},
				isProgress: function (state) {
					if (state === 3 || state === 4)
						return false;
					else
						return true;
				}
			}
		);
		
		var videoPanel = Ext.create(Ext.view.View, {
			//height: '100%',
			flex: 1,
			width: '100%',
			itemId: 'video-panel',
			cls: 'takeasy-video as-expandable-grid',
			padding: '0 3 0 3',
			autoScroll: true,
			store: videoFilterStore,
			realStore: videoStore,
			itemSelector: 'div.videoItem',
			tpl: videoXTpl,
			blockRefresh: true,			
			getCustomCmp: function (r) {
				var data = r.data,
					me = this,
					thumbEl = me.el.query('div.videoItem-' + data.cid + ' > div.left')[0],
					pgEl = me.el.query('div.videoItem-' + data.cid + ' > div.center > div.meta  >div.row-two')[0],
					btnGroupEl = me.el.query('div.videoItem-' + data.cid + ' > div.right')[0];								
				
				//add thumbnail
				Ext.create(Ext.Img, {
					itemId: 'takeasy-thumb-' + data.cid,
					renderTo: thumbEl,
					height: 70,
					width: 120,
					style: 'position:absolute;top:0px;bottom:0px;left:0px;right:0px;margin:auto;' +
						'border:1px solid #656666;opacity:0;cursor:pointer;',
					transSrc: function (value) {
						var newValue;
						if (value === '')
							newValue = fn.imageUrl + 'default_thumb.png';
						else
							newValue = Ext.String.htmlDecode(value);
						//return newValue;
						return newValue;
					},
					listeners: {
						afterrender: function (me) {
							me.setSrc(me.transSrc(data.thumbnail));
							me.el.on('load', function () {								
								me.el.fadeIn({ duration: 1000 });
							});
							me.el.on('click', function () {
								btnGroup.items.get('play').handler();
							});
						}
					}
				});

				//add buttons
				var btnGroup =Ext.create(Ext.container.Container, {
					itemId: 'takeasy-buttons-' + data.cid,
					xtype: 'container',
					renderTo: btnGroupEl,
					height: 34,
					width: '100%',
					win: fn.win,
					//style: 'position:absolute;margin:auto;top:0px;bottom:0px;left:0px;',
					style: 'position: absolute; margin: auto; top: 0px; bottom: 0px;',
					layout: {
						type: 'hbox',
						align: 'right'
					},
					items: [
						// {
						// 	xtype: 'tbfill',
						// 	itemId: 'blank',
						// },
						{
							xtype: 'asTEButton',
							itemId: 'play',
							icon: {
								normal: fn.imageUrl + 'video_control/te_play.png',
								//over: fn.imageUrl + 'video_control/play_over.png',
								//pressed: fn.imageUrl + 'video_control/play_pressed.png'
							},
							handler: function () {
								if (data.video_path === '') {
									window.open(data.url, '_blank');
								} else {
									var fileApiUrl = 'apis/fileExplorer/download.cgi',
									file = data.video_path.split('\/').last(),
									path = data.video_path.split(file).first().replace('/volume1', ''),
									streamUrl = AS.ARC.util.getApiUrlWithSid(fileApiUrl, {
										act: 'download',
										mod_cntype: 2,
										path: path,
										file: file,
										total: 1
									}),
									isFirefox = typeof InstallTrigger !== 'undefined';   // Firefox 1.0+

									if (isFirefox && streamUrl.indexOf('.m4a') !== -1) {
										AS.ARC.util.msgDialog(fn.win, 'info', _S('TAKEASY', 'FORMAT_NOT_SUPPORTED') + ' (FIREFOX)');
									} else {
										if (data.is_folder) {
											AS.ARC.core.openApp('app-fileExplorer', data.video_path.split('/volume1')[1]);
										} else if (data.state === 3) {
											window.open(streamUrl);									
										} else {
											window.open(data.url, '_blank');
										}
									}
								}						
							}
						},
						{
							xtype: 'asTEButton',
							itemId: 'download',
							style: 'margin: 0 0 0 25; cursor: pointer;',
							icon: {
								normal: fn.imageUrl + 'video_control/te_download.png',
								//over: fn.imageUrl + 'video_control/download_over.png',
								//pressed: fn.imageUrl + 'video_control/download_pressed.png'
							},
							handler: function (me) {
								fn.mainPanel.el.mask(_S('COMMON', 'LOADING'));
								
								var state = fn.getSidebarState();
								state = (state === 3) ? 1 : state;

								AS.ARC.ajax({
									url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, { act: 'start_download' }),
									params: {
										cid: data.cid,
										list_type: state
									},
									method: 'post',
									win: fn.win,
									success: function (json, opts) {
										me.hide();
										me.up().items.get('pause').show();
										//fn.mainPanel.el.unmask();
										//videoPanel.realStore.load();
									},
									failure: function (json, opts) {
										fn.mainPanel.el.unmask();
										AS.ARC.util.showMsgWindow({
											//5039: _S('TAKEASY', 'UNABLE_FIND_VIDEO')
											5026: _S('TAKEASY', 'INFO_MIGRATION'),
											5043: _S('ERROR', 'NO_SPACE_DISK')
										}, json, fn.win);
									}
								});
							}
						},
						{
							xtype: 'asTEButton',
							itemId: 'pause',
							style: 'margin: 0 0 0 25; cursor: pointer;',
							icon: {
								normal: fn.imageUrl + 'video_control/te_pause.png',
								//over: fn.imageUrl + 'video_control/pause_over.png',
								//pressed: fn.imageUrl + 'video_control/pause_pressed.png'
							},
							handler: function (me) {
								fn.mainPanel.el.mask(_S('COMMON', 'LOADING'));
								var state = fn.getSidebarState();
								state = (state === 3) ? 1 : state;
								AS.ARC.ajax({
									url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, { act: 'stop_download' }),
									params: {
										cid: data.cid,
										list_type: state
									},
									method: 'post',
									win: fn.win,
									success: function (json, opts) {
										me.hide();
										me.up().items.get('download').show();
										fn.mainPanel.el.unmask();
									},
									failure: function (json, opts) {
										fn.mainPanel.el.unmask();
										AS.ARC.util.showMsgWindow({
											//5039: _S('TAKEASY', 'UNABLE_FIND_VIDEO')
										}, json, fn.win);
									}
								});
							}
						},
						{
							xtype: 'asTEButton',
							itemId: 'remove',
							style: 'margin: 0 0 0 25; cursor: pointer;',
							icon: {
								normal: fn.imageUrl + 'video_control/te_remove.png',
								//over: fn.imageUrl + 'video_control/remove_over.png',
								//pressed: fn.imageUrl + 'video_control/remove_pressed.png'
							},
							handler: function (me) {
								fn.mainPanel.el.mask(_S('COMMON', 'LOADING'));

								var doRemove = function (isAll) {
									fn.mainPanel.el.mask(_S('COMMON', 'LOADING'));
									AS.ARC.ajax({
										url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, { act: 'remove_download' }),
										params: {
											cid: data.cid,
											remove_way: isAll
										},
										method: 'post',
										win: fn.win,
										success: function (json, opts) {
											//var panel = document.getElementsByClassName('takeasy-video')[0];
											//Ps.destroy(panel);	
											//fn.mainPanel.el.unmask();
											//videoPanel.realStore.load();
										},
										failure: function (json, opts) {
											fn.mainPanel.el.unmask();
											AS.ARC.util.showMsgWindow({
												//5039: _S('TAKEASY', 'UNABLE_FIND_VIDEO')
												5026: _S('TAKEASY', 'INFO_MIGRATION')
											}, json, fn.win);
										}
									});
								}

								if (data.state === 3) {
									var win = Ext.create('AS.ARC.msgWindow' ,{
										title: _S('COMMON', 'INFORMATION'),
										parentWin: fn.win,
										height: 250,
										iconType: 'info', // info, question, warning
										asItems: [
											{
												xtype: 'displayfield',
												value: _S('COMMON', 'REMOVE_SELECTED_ITEMS')
											},
											{
												xtype: 'radiogroup',
												itemId: 'action',
												width: 200,
												height: 80,
												columns: 1,
												cls: 'checkbox-group-columns-layout-3-0',
												vertical: true,
												items: [
													{
														boxLabel: _S('TAKEASY', 'INFO_DELETE_TASK'),
														name: 'delete',
														inputValue: 0,
														checked: true
													},
													{
														boxLabel: _S('TAKEASY', 'DELETE_TASK_DATA'),
														name: 'delete',
														inputValue: 1
													}
												]
											}
										],
										fbar: [{
											text: _S('COMMON', 'OK'),
											handler: function () {
												var value = win.items.get('main').items.items[0].items.get('action').getValue()["delete"];
												doRemove(value);
												win.close();
											},
										}, {
											text: _S('COMMON', 'CANCEL'),
											handler: function () {
												win.close();
												fn.mainPanel.el.unmask();
											}
										}]
									}).show();
								} else {
									doRemove(0);
								}
								
							}
						}
					],
					listeners: {
						afterrender: function (me) {
							switch (data.state) {
								case 0:
								case 1:
									me.items.get('download').hide();
									me.items.get('pause').show();
									break;
								case 2:								
								case 4:
									me.items.get('download').show();
									me.items.get('pause').hide();
									break;
								case 3:
									if (data.video_exist) {
										me.items.get('download').hide();
										//me.items.get('blank').show();
										me.items.get('play').enable();
									} else {
										me.items.get('download').show();
										//me.items.get('blank').hide();
										me.items.get('play').disable();
									}
									me.items.get('pause').hide();
									break;
								default:
									break;
							}
						}
					}
				});		
			},
			listeners: {
				//refresh: function (me) {					
				//	if (me.store.data.items.length === 0) return;
					
				//	me.store.each(function (r) {
				//		me.getCustomCmp(r);
				//	});
				//},
				afterrender: function (me) {
					var cancel = function (e) {
						if (e.preventDefault) e.preventDefault(); // required by FF + Safari
						e.dataTransfer.dropEffect = 'copy'; // tells the browser what drop effect is allowed here
						return false; // required by IE
					}
					me.el.dom.addEventListener('dragover', cancel);
					me.el.dom.addEventListener('dragenter', cancel);
					me.el.dom.addEventListener('drop', function (e) {
						if (e.preventDefault) e.preventDefault();
						var value = e.dataTransfer.getData('Text'),
							addButton = fn.mainPanel.items.get('topbar').items.get('add');
						addButton.handler(addButton, e, value);
					});
				
					
				}
			}
		});
		var videoPanelPaging = Ext.create('AS.ARC.pagingToolbar', {
			itemId: 'paging',
			width: '100%',
			cls: 'te-video-paging paging-tool-bar',
			//style: 'margin-left: 20px',
			//flex: 1,
			//minHeight: 32,
			store: videoStore,
			listeners: {
				beforechange: function () {
					videoStore.isMask = true;
				}
			}
		});
		var videoPanelCt = Ext.create(Ext.panel.Panel, {
			itemId: 'video-ct',
			layout: { type: 'vbox', align: 'stretch'},
			//style: 'padding-right: 20',
			items: [
				videoPanel,
				videoPanelPaging
			]
		});

		// subscription_Store
		var subscriptStore = Ext.create(Ext.data.Store, {
			//pageSize: 10,
			loadPage: function (page, options) {
				var me = this;
				options = Ext.apply({}, options);
				
				me.currentPage = page;

				me.read(Ext.applyIf(options, {
					page: page,
					start: ((page - 1) * me.pageSize) + 1,
					limit: me.pageSize,
					addRecords: !me.clearOnPageLoad
				}));
			},
			autoLoad: false,
			isScroll: false,
			fields: ['duration', 'url', 'published', 'title', 'state',
				'video_exist', 'video_path', 'thumbnail', 'cid', 'is_folder', 'format', 'location'],
			proxy: {
				type: 'ajax',
				url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, { act: 'list_video_by_subscription' }),
				timeout: 120000,
				actionMethods: {
					create: 'POST',
					read: 'POST',
					update: 'POST',
					destroy: 'POST'
				},
				reader: {
					type: 'json',
					root: 'video_list'//,
					//totalProperty: 'video_count'
				},
				startParam: 'start_index',
				limitParam: 'max_video_count',
				listeners: {
					exception: function (proxy, response, operation, opts) {
						fn.mainPanel.el.unmask();
						
						var json = Ext.JSON.decode(response.responseText);
						
						if (json.error_code === 5005) {return;}
						
						AS.ARC.util.showMsgWindow({
							5501: _S('TAKEASY', 'AUTH_FAILED'),
							5026: _S('TAKEASY', 'INFO_MIGRATION')
						}, json, fn.win);
					}
				}
			},
			listeners: {
				beforeload: function (store, operation, eOpts) {
					subscriptPanel.el.unmask();
					if (subscriptStore.isLoading() || fn.getSidebarState() !== 3) return false;
					if (!subscriptStore.isScroll) {
						fn.mainPanel.down('#subscriptionBody').el.mask(_S('COMMON', 'LOADING'));
					}
				},
				load: function (me, records, successful) {					
					
					if (successful) {
						if (records.length === 0 && me.currentPage !== 1) {
							me.currentPage--;
						}
						subscriptStoreShadow.add(records);
						if (me.isScroll){
							me.isScroll = false;
						}

						var panel = document.getElementsByClassName('takeasy-subscription')[0];
						if (records.length > 0){
							try {
								Ps.destroy(panel);
							} catch (e) {
								console.log(e);
							}
							Ps.initialize(panel, {
								suppressScrollX: true
							});
							Ps.update(panel);
						}
					}			
					
					if (fn.mainPanel.down('#subscriptionBody')) fn.mainPanel.down('#subscriptionBody').el.unmask();
					if (subscriptStoreShadow.getCount() === 0) {
						subscriptPanel.el.mask(_S('TAKEASY', 'NO_SUBSCRIPTION_DATA'), 'as-mask-msg');
					}
				}
			}
		});

		var subscriptStoreShadow = Ext.create(Ext.data.Store, {
			//pageSize: 10,
			autoLoad: false,
			fields: ['duration', 'url', 'published', 'title', 'state',
				'video_exist', 'video_path', 'thumbnail', 'cid', 'is_folder'],
			listeners: {
				clear: function () {					
					subscriptPanel.el.mask(_S('TAKEASY', 'NO_SUBSCRIPTION_DATA'), 'as-mask-msg');
				}
			}
		});

		var subscriptXTpl = new Ext.XTemplate(
			'<tpl for=".">',
				'<div class="subscriptItem subscriptItem-{[this.getIndex(values.url)]} as-expandable-grid-row as-expandable-grid-row-outer-ct">',
					'<div class="row">',
						'<div class="box name">',
							'<div class="thumb" style="width:25%;height:100%;float:left;position:relative;"></div>',
							'<div class="sub-info-ct">',
								'<div class="sub-info">',
									'<div class="sub-info-text" data-qtip="{[Ext.String.htmlEncode(this.getTitle(values.title))]}">{[this.getTitle(values.title)]}</div>',
								'</div>',
							'</div>',
						'</div>',
						'<div class="box relative" style="width:25%;">',
							'<div class="inner">',
								'<label>{[this.getPublish(values.published)]}</label>',
							'</div>',
						'</div>',
						//'<div class="box relative" style="width:20%;">',
						//	'<div class="inner">',
						//		'<label style="color:#CCCCCC;">{[this.getDuration(values.duration)]}</label>',
						//	'</div>',	
						//'</div>',
						'<div class="box relative action" style="width:20%;">',

						'</div>',
					'</div>',
				'</div>',
				'{[this.getCustomCmp(values)]}',
			'</tpl>',
			'<div class="takeasy-subscript-mask" style="display:none;"></div>',
			'<div class="x-clear"></div>',
			{
				getIndex: function (url) {
					return subscriptStore.find('url', url);
				},
				getTitle: function (value) {
					return Ext.String.htmlEncode(value);
				},
				getDuration: function (value) {
					return (value === 0) ? '--:--' : fn.getTimeInfo(value);
				},
				getPublish: function (value) {
					return AS.ARC.util.toSystemTime(0, 0, value);
				},
				getCustomCmp: function (r) {					
					Ext.defer(function () {
						var data = r,
							index = subscriptStore.find('url', r.url),
							me = subscriptPanel,
							currentIndex = subscriptStore.currentPage - 1,
							thumbEl = me.el.query('div.subscriptItem-' + index + ' div.thumb')[currentIndex],
							btnGroupEl = me.el.query('div.subscriptItem-' + index + ' div.action')[currentIndex];
						
						//add thumbnail
						Ext.create(Ext.Img, {
							//itemId: 'takeasy-subscript-thumb-' + index,
							renderTo: thumbEl,
							height: 30,
							width: 50,
							style: 'position:absolute;top:0px;bottom:0px;left:0px;right:0px;margin:auto;' +
								'border:1px solid #656666;opacity:0;cursor:pointer;',
							transSrc: function (value) {
								var newValue;
								if (value === '')
									newValue = fn.imageUrl + 'default_thumb.png';
								else
									newValue = Ext.String.htmlDecode(value);
								return newValue;
							},
							listeners: {
								afterrender: function (me) {

									me.setSrc(me.transSrc(data.thumbnail));
									me.el.on('load', function () {
										me.el.fadeIn({ duration: 1000 });
									});
									me.el.on('click', function () {
										btnGroup.items.get('play').handler();
									});
								}
							}
						});

						//add buttons
						var btnGroup = Ext.create(Ext.container.Container, {
							//itemId: 'takeasy-subscript-buttons-' + index,
							xtype: 'container',
							renderTo: btnGroupEl,
							height: 34,
							width: 75,
							style: 'position:absolute;margin:auto;top:0px;bottom:0px;left:0px;right:0px;',
							layout: {
								type: 'hbox',
								align: 'middle'
							},
							items: [
								{
									xtype: 'asTEButton',
									itemId: 'play',
									icon: {
										normal: fn.imageUrl + 'video_control/te_play.png',
										//over: fn.imageUrl + 'video_control/play_over.png',
										//pressed: fn.imageUrl + 'video_control/play_pressed.png'
									},
									handler: function () {
										/* var fileApiUrl = 'apis/fileExplorer/download.cgi',
											file = data.video_path.split('\/').last(),
											path = data.video_path.split(file).first().replace('/volume1', ''),
											streamUrl = AS.ARC.util.getApiUrlWithSid(fileApiUrl, {
												act: 'download',
												mod_cntype: 2,
												path: path,
												file: file,
												total: 1
											});

										if (data.state === 3) {
											window.open(streamUrl);
										} else {
											window.open(data.url, '_blank');
										} */

										if (data.video_path === '') {
											window.open(data.url, '_blank');
										} else {
											var fileApiUrl = 'apis/fileExplorer/download.cgi',
												file = data.video_path.split('\/').last(),
												path = data.video_path.split(file).first().replace('/volume1', ''),
												streamUrl = AS.ARC.util.getApiUrlWithSid(fileApiUrl, {
													act: 'download',
													mod_cntype: 2,
													path: path,
													file: file,
													total: 1
												});

											if (data.state === 3) {
												var testVedioExist = document.createElement('VIDEO');
												testVedioExist.src = streamUrl;
												testVedioExist.onloadeddata = function() {
													window.open(streamUrl);
												}
												testVedioExist.onerror = function() {
													window.open(data.url, '_blank');
												}
											} else {
												window.open(data.url, '_blank');
											}
										}
									}
								},
								{
									xtype: 'asTEButton',
									itemId: 'download',
									style: 'margin: 0 0 0 25; cursor: pointer;',
									icon: {
										normal: fn.imageUrl + 'video_control/te_download.png',
										//over: fn.imageUrl + 'video_control/download_over.png',
										//pressed: fn.imageUrl + 'video_control/download_pressed.png'
									},
									handler: function (me) {
										fn.mainPanel.el.mask(_S('COMMON', 'LOADING'));
										var action = '',
											params = {
												url: decodeURIComponent(data.url)
											};
										if (data.state === 0 || data.state === -1) {
											action = 'add_download';
											Ext.apply(params, {
												format: data.format
											});
										} else {
											action = 'start_download';
											Ext.apply(params, {
												cid: data.cid
											});
										}

										if (data.location !== '') {
											Ext.apply(params, {
												location: data.location
											});
										}
										AS.ARC.ajax({
											url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, { act: action }),
											timeout: 120000,
											params: params,
											method: 'post',
											win: fn.win,
											success: function (json, opts) {
												data.cid = json.cid;
												data.state = 1;
												me.up().renderButtons(data.state);
												//me.hide();
												//videoPanel.realStore.load();
												//me.up().items.get('pause').show();
												//fn.download_task.add(json.cid, me.up());
												fn.mainPanel.el.unmask();
											},
											failure: function (json, opts) {
												fn.mainPanel.el.unmask();
												AS.ARC.util.showMsgWindow({
													5008: _S('MESSAGE', 'HN00006'),
													5017: _S('TAKEASY', 'TASK_MAXIMUM_LIMIT'),
													5026: _S('TAKEASY', 'INFO_MIGRATION'),
													5043: _S('ERROR', 'NO_SPACE_DISK')
												}, json, fn.win);
											}
										});
									}
								},
								{
									xtype: 'asTEButton',
									itemId: 'pause',
									style: 'margin: 0 0 0 25; cursor: pointer;',
									icon: {
										normal: fn.imageUrl + 'video_control/te_pause.png',
										//over: fn.imageUrl + 'video_control/pause_over.png',
										//pressed: fn.imageUrl + 'video_control/pause_pressed.png'
									},
									handler: function (me) {
										fn.mainPanel.el.mask(_S('COMMON', 'LOADING'));
										var state = fn.getSidebarState();
										state = (state === 3) ? 1 : state;
										AS.ARC.ajax({
											url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, { act: 'stop_download' }),
											params: {
												cid: data.cid,
												list_type: state
											},
											method: 'post',
											win: fn.win,
											success: function (json, opts) {
												data.state = 2;
												me.up().renderButtons(data.state);
												//me.hide();
												//me.up().items.get('download').show();
												//videoPanel.realStore.load();
												fn.mainPanel.el.unmask();

											},
											failure: function (json, opts) {
												fn.mainPanel.el.unmask();
												AS.ARC.util.showMsgWindow({
													//5039: _S('TAKEASY', 'UNABLE_FIND_VIDEO')
												}, json, fn.win);
											}
										});
									}
								},
								{
									xtype: 'component',
									itemId: 'complete',
									height: 24,
									width: 24,
									style: 'margin: 0 0 0 25;',
									cls: 'te-complete-comp',
									handler: function (me) {

									}
								},
								{
									xtype: 'component',
									itemId: 'failed',
									height: 24,
									width: 24,
									style: 'margin: 0 0 0 25;',
									cls: 'te-failed-comp',
									handler: function (me) {
										fn.mainPanel.el.mask(_S('COMMON', 'LOADING'));
										var state = fn.getSidebarState();
										state = (state === 3) ? 1 : state;
										AS.ARC.ajax({
											url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, { act: 'start_download' }),
											params: {
												cid: data.cid,
												list_type: state
											},
											method: 'post',
											win: fn.win,
											success: function (json, opts) {
												data.state = 1;
												me.up().renderButtons(data.state);
												//me.hide();
												//me.up().items.get('pause').show();
												//videoPanel.realStore.load();
												//fn.download_task.add(data.cid, me.up());
												fn.mainPanel.el.unmask();
											},
											failure: function (json, opts) {
												fn.mainPanel.el.unmask();
												AS.ARC.util.showMsgWindow({
													//5039: _S('TAKEASY', 'UNABLE_FIND_VIDEO')
													5026: _S('TAKEASY', 'INFO_MIGRATION'),
													5043: _S('ERROR', 'NO_SPACE_DISK')
												}, json, fn.win);
											}
										});
									}
								}
							],
							renderButtons: function (state) {
								var me = this;
								switch (state) {
									case -1:
									case 0:
									case 2:
										me.items.get('failed').hide();
										me.items.get('complete').hide();
										me.items.get('pause').hide();
										me.items.get('download').show();
										break;
									case 1:
										me.items.get('download').hide();
										me.items.get('failed').hide();
										me.items.get('complete').hide();
										me.items.get('pause').show();
										break;
									case 4:
										me.items.get('download').hide();
										me.items.get('pause').hide();
										me.items.get('complete').hide();
										me.items.get('failed').show();
										break;
									case 3:
										me.items.get('download').hide();
										me.items.get('pause').hide();
										me.items.get('failed').hide();
										me.items.get('complete').show();
										break;
									default:
										break;
								}
							},
							listeners: {
								afterrender: function (me) {
									me.renderButtons(data.state);
								}
							}
						});
					}, 10);
				},
			}
		);

		var subscriptToolPanel = Ext.create('Ext.panel.Panel', {
			itemId: 'subscript-tool-panel',
			hidden: true,
			padding: '8 20 8 20',
			height: 50,
			items: [{
				xtype: 'asFlexbox',
				style: 'justify-content: space-between;',
				items: [{
					xtype: 'displayfield',
					width: 220,
					labelWidth: AS.ARC.config.layout.labelWidthLong,
					cls: 'ts-toolbar-title',
					fieldLabel: _S('TAKEASY', 'ACCOUNT_SUB_VIDS'),
				}, {
					xtype: 'combobox',
					width: 400, 
					itemId: 'subscriptionAccount',
					// fieldLabel: _S('COMMON', 'ACCOUNT'),
					labelWidth: AS.ARC.config.layout.labelWidthMedium,
					listConfig: {
						cls: 'te-subscription-account'
					},
					displayField: 'display',
					valueField: 'value',
					triggerAction: 'all',
					editable: false,
					queryMode: 'local',
					listeners: {
						expand: function() {
							setTimeout(function() {
								var subscriptionAccountLists = document.querySelectorAll('.te-subscription-account');
								subscriptionAccountLists.forEach(function(item, index){
									item.querySelectorAll('.x-boundlist-item').forEach(function(item, index){
										var accountType = fn.subscriptionAccountStrore.data.items[index].raw[2].split(':')[0];
										if (accountType === 'twitch'){
											item.classList.add('twitch');
										} else if (accountType === 'youtube' || accountType === 'youtube-channel') {
											item.classList.add('youtube');
										}
									});
								})
							}, 10);
						},
						change: function(combo, newValue, oldValue, eOpts) {
							if (newValue === null) return false;
							var panel = document.getElementsByClassName('takeasy-subscription')[0];
							try {
								Ps.destroy(panel);
							} catch (e) {
								console.log(e);
							}
							combo.removeCls('ts-combo-' + 'youtube');
							combo.removeCls('ts-combo-' + 'twitch');

							var selectIdx = combo.getSelectedIndex();
							if (selectIdx >= 0) {
								var	combomRawData = combo.store.data.items[selectIdx].raw,
									accountType = combomRawData[2].split(':')[0];
								combo.addCls('ts-combo-' + accountType);
							}

							var selectedId = combo.getValue(),
								proxyUrl = AS.ARC.util.getApiUrlWithSid(fn.apiUrl, { act: 'list_video_by_subscription' }) + '&id=' + selectedId;
							subscriptPanel.realStore.proxy.url = proxyUrl;
							subscriptPanel.store.removeAll();
							subscriptPanel.realStore.loadPage(1);
						},
						select: function(combo, records, eOpts){
							console.log();
						}
					}
				}]
				
			}]
		});

		var subscriptPanel = Ext.create(Ext.view.View, {
			itemId: 'subscript-panel',
			cls: 'takeasy-subscription as-expandable-grid',
			padding: '0 3 0 3',
			autoScroll: true,
			store: subscriptStoreShadow,
			realStore: subscriptStore,
			itemSelector: 'div.subscriptItem',
			tpl: subscriptXTpl,
			blockRefresh: true,
			listeners: {
				afterrender: function (me) {
					me.el.on('scroll', function () {
						var dom = me.el.dom,
							max = dom.scrollHeight - dom.clientHeight;
						
						if (!me.realStore.isLoading()) {
							if (dom.scrollTop > max * 0.9) {
								var nextPage = me.realStore.currentPage + 1;
								me.realStore.isScroll = true;								
								me.realStore.loadPage(nextPage, { addRecord: true });
							}
						}
						if (dom.scrollTop == max) {
							fn.mainPanel.down('#subscriptionBody').el.mask(_S('COMMON', 'LOADING'));					
							//var mask = me.el.query('div.takeasy-subscript-mask');
							//if (mask.length > 0) {
							//	mask[0].style.display = 'block';
							//}
						}
					});
				}
			}
		});

		var subscriptionBody = Ext.create('Ext.container.Container', {
			itemId: 'subscriptionBody',
			items: [
				subscriptToolPanel,
				subscriptPanel
			],
			listeners: {
				show: function(subscriptionBody) {
					// workaround: To append class for platform icon
					var subscriptionAccount = subscriptionBody.down('#subscriptionAccount');

					subscriptionAccount.expand();
					subscriptionAccount.collapse();
				}
			}	
		})

		var contentPanel = Ext.create(Ext.panel.Panel, {
			itemId: 'content',
			region: 'center',
			cls: 'te-panel-bg',
			//style: 'padding-right: 20px',
			layout: 'card',
			items: [
				//videoPanel,
				videoPanelCt,
				subscriptionBody
			]
		});
		return contentPanel;
	},

	getSidebarPanel: function () {
		var fn = this;
		
		var sidebarPanel = Ext.create(Ext.panel.Panel, {
			itemId: 'sidebar',
			region: 'west',
			cls: 'appctl-side-btn te-side-btn te-panel-bg',
			//split: true,
			height: 550,
			width: 200,
			minWidth: 44,
			maxWidth: 200,
			doVideoLayout: function () {
				var contentPanel = fn.mainPanel.items.get('content'),
					videoPanel = contentPanel.items.get('video-ct').items.get('video-panel'),
					state = fn.getSidebarState();

				contentPanel.getLayout().setActiveItem(0);
				videoPanel.store.removeAll();
				videoPanel.realStore.isMask = true;
				
				//videoPanel.realStore.proxy.extraParams.list_type = (state === 3) ? 1 : state;
				//videoPanel.realStore.currentPage = 1;
				videoPanel.realStore.load();
			},
			updateCounter: function (summary) {
				var me = this,
					items = me.items;
				items.get('download').setCount(summary.download);
				items.get('completed').setCount(summary.finish);
				items.get('failed').setCount(summary.failed);
			},
			items: [
				{
					xtype: 'asTESideBtn',
					itemId: 'download',
					icon: fn.imageUrl + 'sidebar/te_downloading.png',
					//iconNormal: fn.imageUrl + 'sidebar/download.png',
					//iconOver: fn.imageUrl + 'sidebar/download_over.png',
					enableToggle: true,
					allowDepress: false,
					//pressed: true,
					toggleGroup: 'toogle-te-sidebar',
					text: _S('COMMON', 'DOWNLOAD'),
					renderTopbar: function () {
						var topbarPanel = fn.mainPanel.items.get('topbar');
						topbarPanel.items.get('pause').show();
						topbarPanel.items.get('resume').show();
						topbarPanel.items.get('clear').show();
					},
					toggleHandler: function (me, state) {
						if (!state) return;
						me.renderTopbar();
						me.up().doVideoLayout();						
					}
				},
				{
					xtype: 'asTESideBtn',
					itemId: 'completed',
					icon: fn.imageUrl + 'sidebar/te_completed.png',
					//iconNormal: fn.imageUrl + 'sidebar/completed.png',
					//iconOver: fn.imageUrl + 'sidebar/completed_over.png',
					enableToggle: true,
					allowDepress: false,
					toggleGroup: 'toogle-te-sidebar',
					text: _S('COMMON', 'COMPLETED'),
					renderTopbar: function () {
						var topbarPanel = fn.mainPanel.items.get('topbar');
						topbarPanel.items.get('pause').hide();
						topbarPanel.items.get('resume').hide();
						topbarPanel.items.get('clear').show();
					},
					toggleHandler: function (me, state) {
						if (!state) return;
						me.renderTopbar();
						me.up().doVideoLayout();						
					}
				},
				{
					xtype: 'asTESideBtn',
					itemId: 'failed',
					icon: fn.imageUrl + 'sidebar/te_fail.png',
					//iconNormal: fn.imageUrl + 'sidebar/failed.png',
					//iconOver: fn.imageUrl + 'sidebar/failed_over.png',
					enableToggle: true,
					allowDepress: false,
					toggleGroup: 'toogle-te-sidebar',
					text: _S('COMMON', 'FAILED'),
					counterCls: 'te-counter-fail',
					renderTopbar: function () {
						var topbarPanel = fn.mainPanel.items.get('topbar');
						topbarPanel.items.get('clear').show();
						topbarPanel.items.get('pause').hide();
						topbarPanel.items.get('resume').show();
					},
					toggleHandler: function (me, state) {
						if (!state) return;
						me.renderTopbar();
						me.up().doVideoLayout();
					}
				},
				{
					xtype: 'asTESideBtn',
					displayCount: false,
					itemId: 'subscript',
					icon: fn.imageUrl + 'sidebar/te_subscriptions.png',
					//iconNormal: fn.imageUrl + 'sidebar/subscription.png',
					//iconOver: fn.imageUrl + 'sidebar/subscription_over.png',
					enableToggle: true,
					allowDepress: false,
					toggleGroup: 'toogle-te-sidebar',
					text: _S('TAKEASY', 'SUBSCRIPTIONS'),
					renderTopbar: function () {
						var topbarPanel = fn.mainPanel.items.get('topbar');
						topbarPanel.items.get('clear').hide();
						topbarPanel.items.get('pause').hide();
						topbarPanel.items.get('resume').hide();
					},
					toggleHandler: function (me, state) {
						if (!state) return;
						me.renderTopbar();
						var contentPanel = fn.mainPanel.items.get('content'),
							topbarPanel = fn.mainPanel.items.get('topbar'),
							subscriptToolPanel = contentPanel.down('#subscript-tool-panel'),
							subscriptPanel = contentPanel.down('#subscript-panel');
						contentPanel.getLayout().setActiveItem(1);
						subscriptPanel.store.removeAll();
						// subscriptPanel.realStore.loadPage(1);
						fn.loadSubscriptionAccount();
					}
				}
			]
		});
		return sidebarPanel;
	},

	loadSubscriptionAccount: function(){
		var fn = this,
			contentPanel = fn.mainPanel.items.get('content'),
			topbarPanel = fn.mainPanel.items.get('topbar'),
			subscriptToolPanel = contentPanel.down('#subscript-tool-panel'),
			subscriptPanel = contentPanel.down('#subscript-panel');
		
		fn.mainPanel.down('#subscriptionBody').el.mask(_S('COMMON', 'LOADING'));
		subscriptPanel.store.removeAll();

		AS.ARC.ajax({
			url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, { act: 'list_subscription' }),
			method: 'post',
			success: function(json, opts) {
				var subsciptionAccouts = [];
				
				json.subscription.each(function(item, index){
					if (item.account_type === 'youtube-channel') {
						item.account_type = 'youtube';
					}
					subsciptionAccouts.push([
						item.account, 
						item.id,
						item.account_type + ':' + item.account
					]);
				});

				fn.subscriptionAccountStrore = new Ext.data.ArrayStore({
					fields: ['display', 'value'],
					data: subsciptionAccouts	
				});

				var subscriptionAccount = subscriptToolPanel.down('#subscriptionAccount'),
					firstAccountRecord = fn.subscriptionAccountStrore.data.items[0];
				subscriptionAccount.bindStore(fn.subscriptionAccountStrore);

				if (firstAccountRecord) {
					fn.mainPanel.down('#subscript-tool-panel').show();
					subscriptionAccount.select(null);
					subscriptionAccount.select(firstAccountRecord);
				} else {
					subscriptionAccount.select(null);
					fn.mainPanel.down('#subscript-tool-panel').hide();
					if (subscriptionAccount.el && subscriptionAccount.el.dom) {
						subscriptionAccount.el.dom.classList.remove('ts-combo-twitch', 'ts-combo-youtube');
					}
					fn.mainPanel.down('#subscriptionBody').el.unmask();
					var linkId = Ext.id();
					fn.mainPanel.down('#subscriptionBody').el.mask(_S('TAKEASY', 'HAVE_NOT_CREATE') + 
							'</br><div style="display: flex; justify-content: center; padding: 0px; background: transparent; border: 0px;"><a class="te-create-accout-link" id=' 
							+ linkId + 
							' href="#" ><span style="vertical-align: super;">' + 
							_S('TAKEASY', 'CREATE_ACCOUNT') + 
							'</span></a></div>',
						'as-mask-msg');
					Ext.defer(function () {
						document.querySelector('#' + linkId).addEventListener('click', function(){
							fn.mainPanel.down('#topbar').down('#preference').handler(true);
						});
					}, 10);					
				}
			},
			failure: function(json, opts) {
			
				AS.ARC.util.showMsgWindow({
					// 5039: _S('TAKEASY', 'UNABLE_FIND_VIDEO')
					// 5026: _S('TAKEASY', 'INFO_MIGRATION')
				}, json, fn.win);
			}
		});

	},

	getTopbarPanel: function () {
		var fn = this;

		fn.platformData = [
			{ 
				src: AS.ARC.util.fixDc(fn.imageUrl + 'select_twitch_icon.png'),
				value: 'TWITCH',
				oauthUrl: ''
			}
		];

		fn.pollingId = 'takeasySubscriptionLoginStatus';
		fn.receiverId = 'takeasySubscription';

		fn.subscriptionStatus = {};

		var addHandler = function (me, e, dropPath) {			
			var nextBtn = Ext.create(Ext.button.Button, {
				text: _S('COMMON', 'NEXT'),
				goDownload: function (cb, isPlaylist) {
					var me = this;
					me.setText(_S('COMMON', 'DOWNLOAD'));
					taskWin.animate({
						to: {
							height: (isPlaylist) ? 450 : 200
						},
						callback: function () {
							if (Ext.isFunction(cb)) cb();
						}
					});
					taskPanel.getLayout().setActiveItem(1);
					if (isPlaylist) {
						videoPanel.itemId = 'playlist';
						// resList.hide();
						resList.show();
						playlistGrid.show();
					} else {
						videoPanel.itemId = 'single';
						resList.show();
						playlistGrid.hide();
					}
				},
				doCheckUrl: function (cb) {
					var me = this,
						value = addUrlPanel.items.get('url').getValue();
					
					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, { act: 'check_url' }),
						params: {
							url: value
						},
						method: 'post',
						win: taskWin,
						success: function (json, opts) {
							savePath.setValue(fn.location);
							taskWin.el.unmask();
							if (!json.playlist) {
								me.goDownload(cb, false);
							} else {
								me.goDownload(cb, true);
							}
						},
						failure: function (json, opts) {
							taskWin.el.unmask();
							AS.ARC.util.showMsgWindow({
								5039: _S('TAKEASY', 'UNABLE_FIND_VIDEO'),
								5026: _S('TAKEASY', 'INFO_MIGRATION')
							}, json, taskWin);
						}
					});
				},
				doAddUrl: function () {
					var value = addUrlPanel.items.get('url').getValue(),
						saveLoc = savePath.getPath(),
						format = resList.getValue();
					
					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, { act: 'add_download' }),
						timeout: 120000,
						params: {
							url: value,
							format: format,
							location: saveLoc
						},
						method: 'post',
						win: taskWin,
						success: function (json, opts) {
							var videoPanel = fn.mainPanel.items.get('content').items.get('video-ct').items.get('video-panel');
							videoPanel.realStore.isMask = true;
							videoPanel.realStore.load();
							taskWin.el.unmask();
							taskWin.close();							
						},
						failure: function (json, opts) {
							taskWin.el.unmask();
							AS.ARC.util.showMsgWindow({
								5008: _S('MESSAGE', 'HN00006'),
								5017: _S('TAKEASY', 'TASK_MAXIMUM_LIMIT'),
								5026: _S('TAKEASY', 'INFO_MIGRATION'),
								5043: _S('ERROR', 'NO_SPACE_DISK')
							}, json, taskWin);
						}
					});
				},
				doAddPlaylist: function () {
					var value = addUrlPanel.items.get('url').getValue(),
						saveLoc = savePath.getPath(),
						format = resList.getValue(),
						urlList = [];

					Ext.each(plsChecker.getSelection(), function (item) {
						urlList.push(item.url);
					});

					var showDuplicate = function (dupSum) {
						var infoWin = new AS.ARC.msgWindow({
							title: _S('COMMON', 'INFORMATION'),
							parentWin: fn.win,
							iconType: 'info', // info, question, warning
							asItems: [{
								xtype: 'displayfield',
								value: Ext.String.format(_S('TAKEASY', 'TASK_DUPLICATE_INFO'), dupSum)
							}],
							fbar: [{
								text: _S('COMMON', 'OK'),
								handler: function () {
									infoWin.close();
								}
							}]
						}).show();
					}

					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, { act: 'add_playlist' }),
						timeout: 120000,
						params: {
							//url: value,
							format: format,
							url: urlList.join(','),
							location: saveLoc
						},
						method: 'post',
						win: taskWin,
						success: function (json, opts) {							
							taskWin.el.unmask();
							taskWin.close();
							var contentPanel = fn.mainPanel.items.get('content'),
								videoPanel = contentPanel.items.get('video-ct').items.get('video-panel');

							//videoPanel.store.removeAll();
							videoPanel.realStore.isMask = true;
							videoPanel.realStore.load();
							if (json.duplicate > 0) {
								showDuplicate(json.duplicate);
							}
						},
						failure: function (json, opts) {
							taskWin.el.unmask();
							AS.ARC.util.showMsgWindow({
								5008: _S('MESSAGE', 'HN00006'),
								5017: _S('TAKEASY', 'TASK_MAXIMUM_LIMIT'),
								5026: _S('TAKEASY', 'INFO_MIGRATION')
							}, json, taskWin);
						}
					});
				},
				doGetFormat: function () {
					var value = addUrlPanel.items.get('url').getValue(),
						cgiAction = (videoPanel.itemId === 'single') ? 'get_format' : 'get_prefer_format';

					taskWin.el.mask(_S('COMMON', 'LOADING'));

					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, { act: cgiAction }),
						params: {
							url: value
						},
						method: 'post',
						win: taskWin,
						success: function (json, opts) {
							var qualityList = [];

							Ext.each(json.formats, function (f, idx) {
								var dimension = f.dimension;

								if (f.dimension.indexOf('x') !== -1) {
									var dimSplit = f.dimension.split('x');
									if (parseInt(dimSplit[0]) < parseInt(dimSplit[1])) {
										dimension = dimSplit[0] + 'p';
									} else {
										dimension = dimSplit[1] + 'p';
									}
								}

								if (videoPanel.itemId === 'single') {
									qualityList.push([
										dimension + ' (' + f.ext + ')',
										f.format
									]);
								} else {
									qualityList.push([
										dimension,
										f.format
									]);
								}
							});
							resList.store.removeAll();
							if (json.formats.length === 0) {
								resList.store.add([[_S('FILE_EXPLORER', 'DATA_DEFAULT'), -1]]);
							} else {
								resList.store.add(qualityList);
							}

							var defaultValue = resList.store.getAt(0).data.format;
							resList.select(defaultValue);

							if (videoPanel.itemId === 'single') {
								taskWin.el.unmask();
							} else {
								playlistGrid.store.proxy.extraParams.url = value;
								playlistGrid.store.load();
							}
						},
						failure: function (json, opts) {
							taskWin.el.unmask();
							AS.ARC.util.showMsgWindow({
								//5039: _S('TAKEASY', 'UNABLE_FIND_VIDEO')
								5026: _S('TAKEASY', 'INFO_MIGRATION')
							}, json, taskWin);
						}
					});
				},
				handler: function (me) {
					var id = taskPanel.getLayout().getActiveItem().itemId;					
					
					switch (id) {
						case 'addUrl':
							taskWin.el.mask(_S('COMMON', 'LOADING'));
							me.doCheckUrl(me.doGetFormat);
							break;
						case 'single':
							taskWin.el.mask(_S('COMMON', 'LOADING'));
							me.doAddUrl();							
							break;
						//case 'multi':
						//	me.goDownload(function () {
						//		me.doGetFormat();								
						//	});
						//	videoPanel.itemId = 'playlist';
						//	break;
						case 'playlist':
							taskWin.el.mask(_S('COMMON', 'LOADING'));
							me.doAddPlaylist();
							break;
						default:
							break;
					}					
				}
			});
			
			var addUrlPanel = Ext.create(Ext.panel.Panel, {
				itemId: 'addUrl',
				bodyStyle: 'border:none;',
				items: [
					{
						xtype: 'displayfield',
						fieldLabel: _S('TAKEASY', 'WEBSITE_SUPPORT'),
						labelWidth: AS.ARC.config.layout.defaultLabelWidth,
						value: _S('TAKEASY', 'WEBSITE_SUPPORT_LIST')
					},
					{
						xtype: 'textfield',
						itemId: 'url',
						vtype: 'url',
						value: dropPath || '',
						width: 500,
						labelWidth: AS.ARC.config.layout.defaultLabelWidth,
						fieldLabel: _S('TAKEASY', 'URLS'),
						allowBlank: false,
						blankText: _S('MESSAGE', 'HF00011'),
						vtypeText: _S('MESSAGE', 'HF00032'),
						msgTarget: AS.ARC.config.msgTarget,
						enableKeyEvents: true,
						listeners: {
							keyup: function (me, e) {
								if (e.getKey() === 13 && me.isValid()) {
									nextBtn.handler(nextBtn);
								}
							}
						}
					}
				]
			});

			var savePath = Ext.create('AS.ARC.apps.takeasy.core.TESavelocation', {
				width: 430,
				fieldLabel: _S('TAKEASY', 'INFO_SAVE_FILES_TO'),
			});

			var browseBtn = Ext.create(Ext.button.Button, {
				margin: '0 0 0 10',
				text: _S('COMMON', 'BROWSE'),
				handler: function () {
					var fs = Ext.create('AS.ARC.apps.takeasy.core.TETreeSelector', {
						parentWin: taskWin,
						objectPath: savePath
					});
					fs.win.show();
				}
			});
			var plsChecker = Ext.create('AS.ARC.checkColumn', {
				dataIndex: 'check',
				enableSelectAll: true,
				menuDisabled: true,
				sortable: false,
				selectAll: function (checked) {
					var me = this,
						checked = checked || true;
					me.setHeaderCheckbox(checked);
					me.checkAll(checked);
				},
				checkBtn: function () {
					if (plsChecker.getSelection().length === 0)
						nextBtn.disable();
					else
						nextBtn.enable();
				},
				width: 25,
				listeners: {
					aftercheckchange: function (column, rowIndex, checked) {
						plsChecker.checkBtn();
					},
					afterheaderclick: function () {
						plsChecker.checkBtn();
					}
				}
			});
			var playlistStore = Ext.create(Ext.data.Store, {
				//pageSize: 10,
				autoLoad: false,
				fields: ['title', 'url', 'check'],
				proxy: {
					type: 'ajax',
					url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, { act: 'list_playlist' }),
					extraParams: {
						url: ''
					},
					actionMethods: {
						create: 'POST',
						read: 'POST',
						update: 'POST',
						destroy: 'POST'
					},
					reader: {
						type: 'json',
						root: 'items'
					},
					listeners: {
						exception: function (proxy, response, operation, opts) {
							AS.ARC.util.showMsgWindow({
								5303: _S('TAKEASY', 'UNABLE_FIND_VIDEO')
							}, Ext.JSON.decode(response.responseText), taskWin);
						}
					}
				},
				listeners: {
					beforeload: function () {
						taskWin.el.mask(_S('COMMON', 'LOADING'));
					},
					load: function (me, rec, successful) {
						if (successful) taskWin.el.unmask();
					}
				}
			});

			var playlistGrid = Ext.create(Ext.grid.GridPanel, {
				itemId: 'grid',
				margin: '10 0 0 0',
				width: '100%',
				multiSelect: true,
				border: 1,
				height: 260,
				store: playlistStore,
				columns: [
					plsChecker,
					{
						dataIndex: 'title',
						flex: 1,
						header: _S('COMMON', 'NAME'),
						menuDisabled: true,
						renderer: function (value, metadata) {
							metadata.tdAttr = 'data-qtip="' + value + '"';
							return value;
						}
					}
				]
			});

			var resList = Ext.create(Ext.form.ComboBox, {
				margin: '15 0 0 0',
				width: 350,
				editable: false,
				labelWidth: AS.ARC.config.layout.defaultLabelWidth,
				fieldLabel: _S('TAKEASY', 'CHOOSE_QUALITY'),
				store: Ext.create(Ext.data.ArrayStore, {
					fields: ['name', 'format']
				}),
				displayField: 'name',
				valueField: 'format',
				queryMode: 'local'
			});

			var videoPanel = Ext.create(Ext.panel.Panel, {
				itemId: 'single',
				bodyStyle: 'border:none;',
				items: [
					{
						xtype: 'container',
						layout: 'hbox',
						items: [
							savePath,
							browseBtn
						]
					},
					resList,
					playlistGrid
				]
			});

			//var playlistPanel = Ext.create(Ext.panel.Panel, {
			//	itemId: 'multi',
			//	bodyStyle: 'border:none;',
			//	layout: 'fit',
			//	items: [playlistGrid]
			//});

			var taskPanel = Ext.create('AS.ARC.panelTop20', {
				layout: 'card',
				buttonApply: nextBtn,
				items: [
					addUrlPanel,
					videoPanel//,
					//playlistPanel
				],
				listeners: {
					afterrender: function () {
						addUrlPanel.items.get('url').focus(true);
					}
				}
			});

			var taskWin = Ext.create('AS.ARC.subWindow', {
				title: _S('TAKEASY', 'ADD_TASK'),				
				layout: 'fit',
				parentWin: fn.win,
				width: 600,
				height: 200,
				fbar: [
					nextBtn,
					{
						text: _S('COMMON', 'CANCEL'),
						handler: function () {
							taskWin.close();
						}
					}],
				items: [taskPanel]	
			}).show();
		}
		// toolbar pause all 
		var pauseHanlder = function () {		
			var panel = document.getElementsByClassName('takeasy-video')[0];
			Ps.destroy(panel);	
			fn.win.el.mask(_S('COMMON', 'LOADING'));
			var state = fn.getSidebarState();
			state = (state === 3) ? 1 : state;
			AS.ARC.ajax({
				url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, { act: 'stop_download' }),
				params: {
					cid: -1,
					list_type: state
				},
				method: 'post',
				win: fn.win,
				success: function (json, opts) {
					var contentPanel = fn.mainPanel.items.get('content'),
					videoPanel = contentPanel.items.get('video-ct').items.get('video-panel');

					videoPanel.store.removeAll();
					videoPanel.realStore.isMask = false;
					videoPanel.realStore.load();
					fn.win.el.unmask();
				},
				failure: function (json, opts) {
					fn.win.el.unmask();
					AS.ARC.util.showMsgWindow({
						//5039: _S('TAKEASY', 'UNABLE_FIND_VIDEO')
					}, json, fn.win);
				}
			});
		}

		// toolbar resume all 
		var resumeHandler = function () {
			fn.win.el.mask(_S('COMMON', 'LOADING'));
			var state = fn.getSidebarState();
			state = (state === 3) ? 1 : state;
			AS.ARC.ajax({
				url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, { act: 'start_download' }),
				params: {
					cid: -1,
					list_type: state
				},
				method: 'post',
				win: fn.win,
				success: function (json, opts) {
					var contentPanel = fn.mainPanel.items.get('content'),
					videoPanel = contentPanel.items.get('video-ct').items.get('video-panel');
					videoPanel.store.removeAll();
					videoPanel.realStore.isMask = false;
					videoPanel.realStore.currentPage = 1;
					videoPanel.realStore.load();
					fn.win.el.unmask();
				},
				failure: function (json, opts) {
					fn.win.el.unmask();
					AS.ARC.util.showMsgWindow({
						//5039: _S('TAKEASY', 'UNABLE_FIND_VIDEO')
						5026: _S('TAKEASY', 'INFO_MIGRATION'),
						5043: _S('ERROR', 'NO_SPACE_DISK')
					}, json, fn.win);
				}
			});
		}
		
		// toolbar clear all 
		var clearHandler = function () {
			//var getSidebarState = function () {
			//	var targetIdx;
			//	//searchBar = topbar.items.get('search-ct').items.get('search');

			//	Ext.ComponentQuery.query('button', fn.mainPanel.items.get('sidebar')).forEach(function (item, index) {
			//		if (item.pressed) {
			//			targetIdx = index;
			//			return false;
			//		}
			//	});

			//	return targetIdx;
			//};

			var doClear = function (cb) {
				AS.ARC.ajax({
					url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, { act: 'remove_download' }),
					params: {
						cid: -1,
						remove_way: 0,
						remove_by_type: fn.getSidebarState()
					},
					method: 'post',
					win: fn.win,
					success: function (json, opts) {
						var panel = document.getElementsByClassName('takeasy-video')[0];
						Ps.destroy(panel);	
		
						var contentPanel = fn.mainPanel.items.get('content'),
							videoPanel = contentPanel.items.get('video-ct').items.get('video-panel');
						videoPanel.store.removeAll();
						videoPanel.realStore.isMask = false;
						videoPanel.realStore.load();
						if (Ext.isFunction(cb)) cb();
						fn.win.el.unmask();
					},
					failure: function (json, opts) {
						fn.win.el.unmask();
						AS.ARC.util.showMsgWindow({
							//5039: _S('TAKEASY', 'UNABLE_FIND_VIDEO')
							5026: _S('TAKEASY', 'INFO_MIGRATION')
						}, json, fn.win);
					}
				});
			}
			var win = new AS.ARC.msgWindow({
				title: _S('COMMON', 'INFORMATION'),
				parentWin: fn.win,
				iconType: 'warning', // info, question, warning
				asItems: [
					{
						xtype: 'displayfield',
						value: _S('TAKEASY', 'CLEAR_ALL_INFO')
					}
				],
				fbar: [{
					text: _S('COMMON', 'OK'),
					handler: function () {						
						doClear(function () {
							win.close();
						});
					},
				}, {
					text: _S('COMMON', 'CANCEL'),
					handler: function () {
						win.close();
						fn.mainPanel.el.unmask();
					}
				}]
			}).show();
		}

		// toolbar preference
		var preferHandler = function (isCreateNewAccount) {

			var applyBtn = Ext.create(Ext.button.Button, {
				text: _S('COMMON', 'OK'),
				handler: function () {
					fn.location = savePath.getValue();

					win.el.mask(_S('COMMON', 'LOADING'));

					var doSet = function () {
						AS.ARC.ajax({
							url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, { act: 'set_general_option' }),
							params: {
								max_download_count: maxActivate.getValue(),
								max_download_speed: maxSpeed.getValue(),
								location: savePath.getPath(),
								max_task_count: maxOverallTask.getValue(),
								clear_finished_task: autoClear.getValue()
							},
							method: 'post',
							win: win,
							success: function (json, opts) {
								var panel = document.getElementsByClassName('takeasy-subscription')[0];
								try {
									Ps.destroy(panel);
								} catch (e) {
									console.log(e);
								}
								
								var contentPanel = fn.mainPanel.items.get('content'),
									subscriptPanel = contentPanel.down('#subscript-panel');
								subscriptPanel.store.removeAll();
								if (fn.getSidebarState() === 3) {																		
									subscriptPanel.realStore.currentPage = 1;
								}

								fn.win.loadSetting();
								fn.loadSubscriptionAccount();
								win.el.unmask();
								win.close();
							},
							failure: function (json, opts) {
								win.el.unmask();
								AS.ARC.util.showMsgWindow({
									//5039: _S('TAKEASY', 'UNABLE_FIND_VIDEO')
									5026: _S('TAKEASY', 'INFO_MIGRATION')
								}, json, win);
							}
						});
					}

					if (maxOverallTask.currentCount > maxOverallTask.getValue()) {
						var confirmWin = Ext.create('AS.ARC.msgWindow', {
							title: _S('COMMON', 'CONFIRMATION'),
							parentWin: win,
							iconType: 'question', // info, question, warning
							asItems: [
								{
									xtype: 'displayfield',
									value: _S('TAKEASY', 'MAX_COUNT_CONFIRM')
								}
							],
							fbar: [
								{
									text: _S('COMMON', 'OK'),
									handler: function () {
										confirmWin.close();
										doSet();
									}
								},
								{
									text: _S('COMMON', 'CANCEL'),
									handler: function () {
										confirmWin.close();
									}
								}
							]
						}).show();
					} else {
						doSet()
					}					
				}				
			});

			var savePath = Ext.create('AS.ARC.apps.takeasy.core.TESavelocation', {
				labelWidth: AS.ARC.config.layout.labelWidthLong,
				fieldLabel: _S('TAKEASY', 'DEFAULT_DOWNLOAD_DIR'),
			});

			var browseBtn = Ext.create(Ext.button.Button, {
				margin: '0 0 0 10',
				text: _S('COMMON', 'BROWSE'),
				handler: function () {
					var fs = Ext.create('AS.ARC.apps.takeasy.core.TETreeSelector', {
						parentWin: win,
						objectPath: savePath
					});
					fs.win.show();
				}
			});

			var maxActivate = Ext.create(Ext.form.ComboBox, {
				itemId: 'max',
				margin: '10 0 0 0',
				//width: 380,
				editable: false,
				labelWidth: AS.ARC.config.layout.labelWidthLong,
				fieldLabel: _S('TAKEASY', 'MAXINUM_ACTIVE_TASK'),
				store: new Ext.data.ArrayStore({
					fields: ['display', 'value'],
					data: [
						['1', 1],
						['2', 2],
						['3', 3]
					]
				}),
				displayField: 'display',
				valueField: 'value',
				queryMode: 'local',
			});

			var maxSpeed = Ext.create(Ext.form.ComboBox, {
				itemId: 'speed',
				margin: '10 0 0 0',
				//width: 400,
				editable: false,
				labelWidth: AS.ARC.config.layout.labelWidthLong,
				fieldLabel: _S('TAKEASY', 'MAXINUM_SPEED'),
				store: new Ext.data.ArrayStore({
					fields: ['display', 'value'],
					data: [
						[_S('TAKEASY', 'UNLIMITED'), -1],
						['4 Mbps', 4 * Math.pow(1024, 2)],
						['3 Mbps', 3 * Math.pow(1024, 2)],
						['2 Mbps', 2 * Math.pow(1024, 2)],
						['1 Mbps', 1 * Math.pow(1024, 2)],
						['800 Kbps', 800 * 1024],
						['400 Kbps', 400 * 1024],
						['200 Kbps', 200 * 1024],
						['100 Kbps', 100 * 1024],
						['50 Kbps', 50 * 1024]
					]
				}),
				displayField: 'display',
				valueField: 'value',
				queryMode: 'local',
				//editable: false
			});

			var maxOverallTask = Ext.create(Ext.form.ComboBox, {
				itemId: 'maxtask',
				margin: '10 0 0 0',
				//width: 400,
				editable: false,
				labelWidth: AS.ARC.config.layout.labelWidthLong,
				fieldLabel: _S('TAKEASY', 'AUTO_CLEAR_ALL'),
				store: new Ext.data.ArrayStore({
					fields: ['display', 'value'],
					data: [
						['100', 100],
						['200', 200],
						['300', 300],
						['400', 400],
						['500', 500]
					]
				}),
				displayField: 'display',
				valueField: 'value',
				queryMode: 'local',
				//editable: false
			});

			var autoClear = Ext.create(Ext.form.ComboBox, {
				itemId: 'autoclear',
				margin: '10 0 0 0',
				//width: 400,
				editable: false,
				labelWidth: AS.ARC.config.layout.labelWidthLong,
				fieldLabel: _S('TAKEASY', 'MAX_OVERALL_TASK'),
				store: new Ext.data.ArrayStore({
					fields: ['display', 'value'],
					data: [
						[_S('COMMON', 'ENABLE'), 1],
						[_S('COMMON', 'DISABLE'), 0]
					]
				}),
				displayField: 'display',
				valueField: 'value',
				queryMode: 'local',
				editable: false
			});

			var generalTab = Ext.create('AS.ARC.panelTop20', {
				itemId: 'general',
				title: _S('COMMON', 'GENERAL'),
				items: [
					{
						xtype: 'container',
						layout: 'hbox',
						items: [
							savePath,
							browseBtn
						]
					},
					maxActivate,
					maxSpeed,
					maxOverallTask,
					autoClear
				],
				loadData: function() {
					generalTab.el.mask(_S('COMMON', 'LOADING'));
					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, { act: 'get_general_option' }),
						method: 'post',
						win: win,
						success: function(json, opts) {
							maxActivate.setValue(json.max_download_count);
							maxSpeed.setValue(json.max_download_speed);
							maxOverallTask.setValue(json.max_task_count);
							maxOverallTask.currentCount = json.count;
							autoClear.setValue(json.clear_finished_task);
							var location;

							if (json.location === '') {
								location = '';
							} else {
								// location = decodeURIComponent(json.location).split('volume1')[1];
								location = json.location;
							}
							savePath.setValue(location);
							fn.location = location;
							fn.renderInsufficient();
							generalTab.el.unmask();
						},
						failure: function(json, opts) {
							AS.ARC.util.showMsgWindow({
								//5039: _S('TAKEASY', 'UNABLE_FIND_VIDEO')
							}, json, win);
						}
					});
				},
				listeners: {
					afterrender: function(me) {
						me.loadData();
					}
				}
			});

			var accountHandler = function(action) {
				Ext.define('platformModel', {
					extend: 'Ext.data.Model',
					fields: [
						{ name:'src', type:'string' },
						{ name:'value', type:'string' }
					]
				});
		

				var platformStore = Ext.create('Ext.data.Store', {
					model: 'platformModel',
					data: fn.platformData
				});
				
				var platformTpl = new Ext.XTemplate(
					'<tpl for=".">',
						'<div class="thumb-wrap te-platform">',
							'<div class="te-platform-item" style="background-image: url({src});"> </div>',
						'</div>',
					'</tpl>'
				);

				var createAddYoutubeChannelWin = function() {
					var addYoutubeChannel = function(channelUrl) {
						addYoutubeChannelWin.el.mask(_S('COMMON', 'APPLYING'));
						AS.ARC.ajax({
							url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl),
							params: {
								act: 'add_youtube_channel',
								channel_url: channelUrl
							},
							method: 'get',
							success: function (json, opts) {
								fn.platformData.each(function(item, index){
									var platform = platformPicker.el.dom.childNodes[index];

									platformPicker.el.dom.style.pointerEvents = 'none';
									platform.style.pointerEvents = 'none';
									if (item.value === 'TWITCH') {
										platform.style.opacity = '0.5';
									} else {
										platformPicker.select(index);
									}
								});
								addYoutubeChannelWin.close();
								addWin.el.mask(_S('COMMON', 'LOADING'));
							},
							failure: function (json, opts) {
								AS.ARC.util.showMsgWindow({
									5302: _S('ERROR', 'UNABLE_OBTAIN_INFO'),
									5401: _S('ERROR', 'UNKNOWN_ERROR')
								}, json, addYoutubeChannelWin);
							}
						});
					}

					var addYoutubeChannelWin = Ext.create('AS.ARC.subWindow', {
						title: _S('TAKEASY', 'Y_CHANNEL_SETTINGS'),				
						parentWin: addWin,
						id: 'add-youtube-channel-win',
						width: 585,
						height: 225,
						fbar: [{
								text: _S('COMMON', 'OK'),
								disabled: true,
								handler: function () {
									addYoutubeChannel(addYoutubeChannelWin.down('#youtubeChannelUrl').getValue());
								}
							},
							{
								text: _S('COMMON', 'CANCEL'),
								handler: function () {
									fn.platformData.each(function(item, index){
										platformPicker.deselect(index);
									});	
									addYoutubeChannelWin.close();
								}
						}],
						items: [{
							xtype: 'asPanelTop20',
							items: [{
									xtype: 'textfield',
									itemId: 'youtubeChannelUrl',
									vtype: 'url',
									value: '',
									width: 500,
									labelWidth: AS.ARC.config.layout.defaultLabelWidth,
									fieldLabel: _S('TAKEASY', 'CHANNEL_ADDR'),
									allowBlank: false,
									blankText: _S('MESSAGE', 'HF00011'),
									vtypeText: _S('MESSAGE', 'HF00032'),
									msgTarget: AS.ARC.config.msgTarget,
									enableKeyEvents: true,
									listeners: {
										keyup: function (me, e) {
											var okBtn = me.up().up().dockedItems.items[1].items.items[0];
											okBtn.setDisabled(!me.isValid());
					
											if (e.getKey() === 13 && me.isValid()) {
												addYoutubeChannel(addYoutubeChannelWin.down('#youtubeChannelUrl').getValue());
											}
										}
									}
							}, {
								xtype: 'displayfield',
								fieldLabel: _S('TAKEASY', 'EXAMPLE'),
								labelWidth: AS.ARC.config.layout.defaultLabelWidth,
								value: 'https://www.youtube.com/channel/UCEMJ6cVqEM9ptIOVWXAj7Zg'
							}]
						}],
						listeners: {
							afterrender: function(addYoutubeChannelWin) {
								addYoutubeChannelWin.down('#youtubeChannelUrl').validate();
							}
						}
					}).show();
				}

				var platformPicker = Ext.create('Ext.view.View', {
					store: platformStore,
					tpl: platformTpl,
					itemId: 'platformPicker',
					itemSelector: 'div.te-platform',
					style: {
						width: '100%',
						display: 'flex',
						position: 'relative',
					},
					listeners:{
						select: function(view, records) {
							// console.log(records.data.oauthUrl);
							if (!fn.subscriptionStatus.login || (fn.subscriptionStatus.login && fn.subscriptionStatus.account_type.toUpperCase() !== records.data.value)) {
								fn.subscriptionStatus = {};

								if (records.data.value === 'TWITCH') {
									fn.oauthWin = window.open(records.data.oauthUrl, "newwindow", "height=480, width=480, toolbar=no, menubar=no, scrollbars=no, resizable=no, location=no, status=no");
									var winCloseDetector = setInterval(function () {
										try {
											if (fn.oauthWin == null || (fn.oauthWin && fn.oauthWin.closed)) {
												clearInterval(winCloseDetector);
											}
										}
										catch (e) {
										}
									}, 1000);
								} else if (records.data.value === 'YOUTUBE') {
									createAddYoutubeChannelWin();
								}
							}	
						},
						selectionchange: function(view, selections, eOpts) {
							addWin.el.mask(_S('COMMON', 'LOADING'));
						},
						afterrender: function(platformPickerView) {
							if (action === 'edit') {
								Ext.defer(function () {
									fn.platformData.each(function(item, index){
										var platform = platformPickerView.el.dom.childNodes[index],
											selactionData = subscriptGrid.getSelectionModel().getSelection()[0].data;

										platformPickerView.el.dom.style.pointerEvents = 'none';
										platform.style.pointerEvents = 'none';
										if (item.value === selactionData.account_type.toUpperCase()) {
											platform.classList.add('x-item-selected');
										} else {
											platform.style.opacity = '0.5';
										}
									});
								}, 10);
							}
						}
					}
				});

				var platforms =  Ext.create('AS.ARC.flexbox',{
					cls: 'common-layout-horizontal-3-0 theme',
					style: 'justify-content: space-around',
					items:[{
						xtype: 'displayfield',
						fieldLabel:  _S('TAKEASY','SELECT_PLATFORM'),
						labelWidth: AS.ARC.config.layout.defaultLabelWidth,
					},
						platformPicker	
					]
				});

				var subscribeSavePath = Ext.create('AS.ARC.apps.takeasy.core.TESavelocation', {
					width: 430,
					fieldLabel: _S('TAKEASY', 'INFO_SAVE_FILES_TO'),
				});
	
				var subscribeBrowseBtn = Ext.create(Ext.button.Button, {
					margin: '0 0 0 10',
					text: _S('COMMON', 'BROWSE'),
					handler: function () {
						var fs = Ext.create('AS.ARC.apps.takeasy.core.TETreeSelector', {
							parentWin: addWin,
							objectPath: subscribeSavePath
						});
						fs.win.show();
					}
				});

				var subscribeDownloadDiractory = Ext.create('AS.ARC.flexbox',{
					cls: 'common-layout-horizontal-3-0',
					items:[
						subscribeSavePath,
						subscribeBrowseBtn
					]
				})

				var account = Ext.create(Ext.form.DisplayField, {
					accId: '',
					labelWidth: AS.ARC.config.layout.defaultLabelWidth,
					fieldLabel: _S('COMMON', 'ACCOUNT'),
					value: AS.ARC.datas.defaultValue,
					width: 550
				});

				var preferFormat = Ext.create(Ext.form.ComboBox, {
					editable: false,
					labelWidth: AS.ARC.config.layout.defaultLabelWidth,
					fieldLabel: _S('TAKEASY', 'CHOOSE_QUALITY'),
					store: Ext.create(Ext.data.Store, {
						autoLoad: true,
						fields: ['format', 'dimension'],
						proxy: {
							type: 'ajax',
							url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act: 'get_prefer_format'}),
							actionMethods: {
								create: 'POST',
								read: 'POST',
								update: 'POST',
								destroy: 'POST'
							},
							reader: {
								type: 'json',
								root: 'formats'
							}
						},
						listeners: {
							load: function(me) {
								if (action === 'add') {
									var defaultValue = me.getAt(0);
									preferFormat.select(defaultValue);
								} else {
									var selData = subscriptGrid.getSelectionModel().getSelection()[0].data,
										format = selData.format;
										index = preferFormat.findRecordByValue(selData.format).index;

									preferFormat.select(me.getAt(index));
								}
							}
						}
					}),
					displayField: 'dimension',
					valueField: 'format',
					queryMode: 'local'
				});

				var channelClassLocation = Ext.create(Ext.form.Checkbox, {
					boxLabel: _S('TAKEASY', 'CLASSIFIED_CHANNEL')
				});

				var enableAuto = Ext.create(Ext.form.Checkbox, {
					boxLabel: _S('TAKEASY', 'ENABLE_AUTO_DOWNLOAD')
				});

				var checkNewSubscription = function() {
					AS.ARC.config.pollingManager.cgiPollingConfig[fn.pollingId] = {
						method: 'get',
						name: 'video_downloader.cgi',
						path: '../../apps/takeasy',
						params: {
							act: 'check_new_subscription',
						},
						frequency: 3000
					};

					fn.newSubscriptionReceiver = {
						id: fn.receiverId,
						notifyByPollingManager: (function(json) {
							//  console.log(json);
							fn.subscriptionStatus = json;

							if (json.account_type === 'youtube-channel') {
								fn.subscriptionStatus.account_type = 'youtube';
							}

							if (platformPicker.isDestroyed) {
								return false;
							}

							var resetPanelValue = function() {
								applyBtn.disable();
								(function deselectAll(){
									fn.platformData.each(function(item, index){
										platformPicker.deselect(index);
									});	
								})();
								addWin.el.unmask();
							}

							if (fn.subscriptionStatus.success === false) {
								AS.ARC.util.showMsgWindow({
									5044: _S('TAKEASY', 'CHANNEL_ALREADY_EXIST'),
								}, fn.subscriptionStatus, addWin, 'warning', function(){
									resetPanelValue();
									try {
										AS.ARC.pollingManager.removeRegister(fn.pollingId, fn.newSubscriptionReceiver);
									} catch (e) {
										console.log(e);
									}
									addWin.close();
								});
								return false;
							}

							if (fn.subscriptionStatus.login === false) {
								applyBtn.disable();
								if (fn.oauthWin === null || fn.oauthWin === undefined || (fn.oauthWin && fn.oauthWin.closed)) {
									if (document.querySelector('#add-youtube-channel-win')) {
										return false;
									}
									resetPanelValue();
								}
								return false;
							} else if (fn.subscriptionStatus.login === true) {
								var setPanelValue = function() {
									fn.platformData.each(function(item, index){
										var platform = platformPicker.el.dom.childNodes[index];
										platformPicker.el.dom.style.pointerEvents = 'none';
										platform.style.pointerEvents = 'none';
										if (item.value === fn.subscriptionStatus.account_type.toUpperCase()) {
											platformPicker.select(index);
										} else {
											platform.style.opacity = '0.5';
										}
									});

									account.setValue(fn.subscriptionStatus.account);
									applyBtn.enable();							
									addWin.el.unmask();
								}

								setPanelValue();
							}
						}).bind(fn),
					};

					AS.ARC.pollingManager.register(fn.pollingId, fn.newSubscriptionReceiver);
				};

				var cgiAction = (action === 'add') ? 'add_subscription' : 'set_subscription';

				var applyBtn = Ext.create(Ext.button.Button, {
					text: _S('COMMON', 'OK'),
					disabled: true,
					handler: function() {
						addWin.el.mask(_S('COMMON', 'LOADING'));
						var selection = subscriptGrid.getSelectionModel().getSelection(),
							paras = {};
						if (action === 'edit') {
							var selectionData = selection[0].data;
							paras = {
								id :selectionData.id,
								format: preferFormat.getValue(),
								location: subscribeSavePath.getPath(),
								enable_auto_download: enableAuto.getValue() ? true : false,
								location_by_channel: channelClassLocation.getValue() ? true : false,
							}
						} else if ('add') {
							Ext.apply(paras, {
								format: preferFormat.getValue(),
								location: subscribeSavePath.getPath(),
								enable_auto_download: enableAuto.getValue() ? true : false,
								location_by_channel: channelClassLocation.getValue() ? true : false,
							})
						}
						AS.ARC.ajax({
							url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, { act: cgiAction }),
							params:	paras,
							method: 'post',
							win: win,
							success: function(json, opts) {
								try {
									AS.ARC.pollingManager.removeRegister(fn.pollingId, fn.newSubscriptionReceiver);
								} catch (e) {
									console.log(e);
								}
								subscriptGrid.store.load();
								fn.loadSubscriptionAccount();
								addWin.close();
							},
							failure: function(json, opts) {

								AS.ARC.util.showMsgWindow({
									//5039: _S('TAKEASY', 'UNABLE_FIND_VIDEO')
									5026: _S('TAKEASY', 'INFO_MIGRATION')
								}, json, addWin);
							}
						});
					}
				});

				var addWin = Ext.create('AS.ARC.subWindow', {
					title: _S('WEBINSTALL', 'CREATE_NEW_ACCOUNT_TITLE'),
					parentWin: win,
					width: 600,
					height: 380,
					layout: 'fit',
					doEdit: function() {
						var selData = subscriptGrid.getSelectionModel().getSelection()[0].data,
							win = this,
							defaultDownloadValue = Ext.create('AS.ARC.apps.takeasy.core.TESavelocation', {
								width: 430,
								fieldLabel: _S('TAKEASY', 'INFO_SAVE_FILES_TO'),
							}).value;

						win.setTitle(_S('COMMON', 'EDIT'));
						account.setValue(selData.account);
						channelClassLocation.setValue((selData.location_by_channel));
						// preferFormat.setValue(selData.format);	// preferFormat 在讀取後會選擇
						enableAuto.setValue((selData.enable_auto_download === true) ? true : false);
						subscribeSavePath.setValue(selData.location === '' ? defaultDownloadValue : selData.location);
						applyBtn.enable();
						win.el.unmask();
					},
					doAdd: function() {
						var win = this;

						checkNewSubscription();
						win.setTitle(_S('TAKEASY', 'SUB_SETTINGS'));
						// account.reset();
						enableAuto.reset();
						win.el.unmask();
					},
					loadData: function() {
						var me = this;
						if (action === 'edit') {
							me.doEdit();
						} else {
							me.doAdd();
						}
					},
					fbar: [
						applyBtn,
						{
							text: _S('COMMON', 'CANCEL'),
							handler: function() {
								try {
									AS.ARC.pollingManager.removeRegister(fn.pollingId, fn.newSubscriptionReceiver);
								} catch (e) {
									console.log(e);
								}								
								addWin.close();
							}
						}],
					items: [
						{
							xtype: 'asPanelTop20',
							buttonApply: applyBtn,
							items: [
								platforms,
								account,
								subscribeDownloadDiractory,
								preferFormat,
								channelClassLocation,
								enableAuto,
							]
						}
					],
					listeners: {
						afterrender: function(me) {
							me.el.mask(_S('COMMON', 'LOADING'));
							me.loadData();
						}
					}
				}).show();
			}

			var addBtn = Ext.create(Ext.button.Button, {
				text: _S('COMMON', 'ADD'),
				handler: function() {
					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, { act: 'list_subscription' }),
						method: 'post',
						win: win,
						success: function(json, opts) {
							(function initOauthUrl() {
								var admPosition = encodeURIComponent("&adm_url=" + encodeURIComponent(location.protocol + '//' + location.host + '/'));
								fn.platformData[0].oauthUrl = json.twitch_login_url + admPosition;
							})();
							
							accountHandler('add');
						},
						failure: function(json, opts) {
							subscriptTab.el.unmask();
							AS.ARC.util.showMsgWindow({
								// 5039: _S('TAKEASY', 'UNABLE_FIND_VIDEO')
								// 5026: _S('TAKEASY', 'INFO_MIGRATION')
							}, json, win);
						}
					});

				}
			});

			var editBtn = Ext.create(Ext.button.Button, {
				disabled: true,
				text: _S('COMMON', 'EDIT'),
				handler: function() { 
					accountHandler('edit');
				}
			});

			var deleteBtn = Ext.create(Ext.button.Button, {
				disabled: true,
				text: _S('COMMON', 'DELETE'),
				handler: function() {
					subscriptTab.el.mask(_S('COMMON', 'LOADING'));
					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, { act: 'remove_subscription' }),
						params: {
							id: subscriptGrid.getSelectionModel().getSelection()[0].data.id
						},
						method: 'post',
						win: win,
						success: function(json, opts) {
							subscriptTab.el.unmask();
							subscriptGrid.store.load();
							fn.loadSubscriptionAccount();
						},
						failure: function(json, opts) {
							subscriptTab.el.unmask();
							AS.ARC.util.showMsgWindow({
								//5039: _S('TAKEASY', 'UNABLE_FIND_VIDEO')
								5026: _S('TAKEASY', 'INFO_MIGRATION')
							}, json, win);
						}
					});
				}
			});

			var subscriptStore = Ext.create(Ext.data.Store, {
				autoLoad: false,
				fields: ['account_type', 'id', 'account', 'code',
					'enable_auto_download', 'auto_download_count',
					'format', 'location_by_channel', 'location', 'dimension'
				],
				fields: [{
					name: 'account_type',
					convert: function (v, record) {
						if (record.raw.account_type === 'youtube-channel') {
							return 'youtube';
						}
						return record.raw.account_type;
					},
				},
				'id', 
				'account', 
				'code',
				'enable_auto_download',
				'auto_download_count',
				'format', 
				'location_by_channel',
				'location',
				'dimension'
			],
				proxy: {
					type: 'ajax',
					url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, { act: 'list_subscription' }),
					actionMethods: {
						create: 'POST',
						read: 'POST',
						update: 'POST',
						destroy: 'POST'
					},
					reader: {
						type: 'json',
						root: 'subscription'
					}
				},
				listeners: {
					beforeload: function() {
						subscriptTab.el.mask(_S('COMMON', 'LOADING'));
					},
					load: function() {
						subscriptTab.el.unmask();
					}
				}
			});
			var subscriptGrid = Ext.create(Ext.grid.GridPanel, {
				cls: 'te-subscription-grid',
				width: '100%',
				height: 145,
				multiSelect: true,
				border: 1,
				store: subscriptStore,
				columns: [
					{
						dataIndex: 'account_type',
						flex: 2,
						header: _S('TAKEASY', 'PLATFORM'),
						menuDisabled: true,
						draggable: false,
						renderer: function(value, metadata) {
							return value;
						}
					},
					{
						dataIndex: 'account',
						flex: 3,
						header: _S('COMMON', 'ACCOUNT'),
						menuDisabled: true,
						renderer: function(value, metadata) {
							metadata.tdAttr = 'data-qtip="' + value + '"';
							return value;
						}
					},
					{
						dataIndex: 'location',
						flex: 2,
						header: _S('TASKMONITOR', 'LOCATION'),
						menuDisabled: true,
						renderer: function(value, metadata) {
							if (value === '') {
								var defaultDownloadValue = Ext.create('AS.ARC.apps.takeasy.core.TESavelocation', {
									width: 430,
									fieldLabel: _S('TAKEASY', 'INFO_SAVE_FILES_TO'),
								}).value;

								metadata.tdAttr = 'data-qtip="' + defaultDownloadValue + '"';
								return defaultDownloadValue;
							} else {
								metadata.tdAttr = 'data-qtip="' + value + '"';
								return value;
							}
						}
					},
					{
						dataIndex: 'enable_auto_download',
						flex: 2,
						header: _S('TAKEASY', 'AUTO_DOWNLOAD'),
						menuDisabled: true,
						renderer: function(value, metadata) {
							if (value === true)
								value = _S('SYSTEMINFORMATION', 'ENABLED');
							else
								value = _S('COMMON', 'DISABLED');
							//metadata.tdAttr = 'data-qtip="' + value + '"';
							return value;
						}
					}
				],
				listeners: {
					selectionchange: function(me, selected) {
						if (selected.length === 1) {
							editBtn.enable();
							deleteBtn.enable();
						} else {
							editBtn.disable();
							deleteBtn.disable();
						}
					}
				}
			});

			var subscriptTab = Ext.create('AS.ARC.panelTop20', {
				itemId: 'subscript',
				title: _S('TAKEASY', 'SUBSCRIPTIONS'),
				loadData: function() {
					subscriptGrid.store.load();
				},
				items: [
					{
						xtype: 'asPanelToolbarTop',
						itemId: 'tbar',
						cls: 'as-tooltopbar-common-layout-3-0',
						items: [
							addBtn,
							editBtn,
							deleteBtn
						]
					},
					subscriptGrid,
					{
						xtype: 'displayfield',
						value: _TS_ING('TAKEASY', 'TWITCH_SUBSCRIPTION_INFO'),
						cls: 'displayField note-string'
					}
				],
				listeners: {
					afterrender: function (me) {
						me.loadData();
					}
				}
			});

			var tabPanel = Ext.create('AS.ARC.formTabPanel', {
				//buttonApply: buttonApply,
				deferredRender: false,
				buttonApply: applyBtn,
				layout: 'fit',
				items: [
					generalTab,
					subscriptTab
				]
			});

			var win = Ext.create('AS.ARC.subWindow', {
				title: _S('COMMON', 'PREFERENCES'),
				parentWin: fn.win,
				width: 750,
				height: 450,
				layout: 'fit',
				fbar: [
					applyBtn,
					{
						text: _S('COMMON', 'CANCEL'),
						handler: function () {
							win.close();
						}
					}],
				items: [tabPanel],
				listeners: {
					afterrender: function () {
						if (isCreateNewAccount === true) {
							tabPanel.setActiveTab(1);
							addBtn.handler();
						}
					}
				}
			}).show();		
		}

		var topbarPanel = Ext.create(Ext.panel.Panel, {
			itemId: 'topbar',
			region: 'north',
			height: 39,
			cls: 'te-topbar',
			layout: 'hbox',
			items: [
				{
					xtype: 'asTEButton',
					itemId: 'add',
					//margin: '0 0 0 20',
					style: 'left: 20px; margin: 0 0 0 20; cursor: pointer;',
					tooltip: _S('TAKEASY', 'ADD_NEW_LINK'),
					icon: {
						normal: fn.imageUrl + 'topbar/te_add.png',
						//over: fn.imageUrl + 'topbar/add_over.png',
						//pressed: fn.imageUrl + 'topbar/add_pressed.png'
					},
					handler: addHandler
				},
				{
					xtype: 'asTEButton',
					itemId: 'pause',
					disabled: true,
					tooltip: _S('TAKEASY', 'PAUSE_ALL'),
					style: 'left: 15px; margin: 0 0 0 15; cursor: pointer;',
					icon: {
						normal: fn.imageUrl + 'topbar/te_pause.png',
						//over: fn.imageUrl + 'topbar/pause_over.png',
						//pressed: fn.imageUrl + 'topbar/pause_pressed.png'
					},
					handler: pauseHanlder
				},
				{
					xtype: 'asTEButton',
					itemId: 'resume',
					disabled: true,
					tooltip: _S('TAKEASY', 'RESUME_ALL'),
					style: 'left: 15px; margin: 0 0 0 15; cursor: pointer;',
					icon: {
						normal: fn.imageUrl + 'topbar/te_resume.png',
						//over: fn.imageUrl + 'topbar/resume_over.png',
						//pressed: fn.imageUrl + 'topbar/resume_pressed.png'
					},
					handler: resumeHandler
				},
				{
					xtype: 'asTEButton',
					itemId: 'clear',
					disabled: true,
					tooltip: _S('TAKEASY', 'CLEAR_ALL'),
					style: 'left: 15px; margin: 0 0 0 15; cursor: pointer;',
					icon: {
						normal: fn.imageUrl + 'topbar/te_clear.png',
						//over: fn.imageUrl + 'topbar/clear_over.png',
						//pressed: fn.imageUrl + 'topbar/clear_pressed.png'
					},
					handler: clearHandler
				},
				{
					xtype: 'tbfill'
				},
				{
					xtype: 'asTEButton',
					itemId: 'preference',
					tooltip: _S('COMMON', 'PREFERENCES'),
					style: 'right: 20px; margin: 0 20 0 0; cursor: pointer;',
					icon: {
						normal: fn.imageUrl + 'topbar/te_preference.png',
						//over: fn.imageUrl + 'topbar/preference_over.png',
						//pressed: fn.imageUrl + 'topbar/preference_pressed.png'
					},
					handler: preferHandler
				}
			]
		});
		return topbarPanel;
	}

});

/**
 * @class AS.ARC.apps.takeasy.main
 * @extends AS.ARC._appBase
 * <p>Main app</p>
 */
Ext.define('AS.ARC.apps.takeasy.main', {
	extend: 'AS.ARC._appBase',

	appTag: 'takeasy',
	//title: _S('ITUNES_SERVER', 'ITUNES_SERVER'),
	title: 'Takeasy',
	appMaxNum: 1,
	appOpenNum: 0,
	appIsReady: true,
	appWins: [],
	
	createWindow: function () {
		var desktop = this.core.getDesktop(),			
			app = this;
		
		if ((this.appOpenNum === this.appMaxNum) || !this.appIsReady) {
			this.appWins[0].show();
			return;
		}
		
		// Set appIsReady to false
		this.appIsReady = false;

		var takeasy = new AS.ARC.apps.takeasy.core({
			app: this,
			desktop: desktop,
			id: this.id + '-' + Ext.id()
			//id: this.id
		});
		
		takeasy.win.on('render', function () {
			app.appOpenNum++;
			app.appIsReady = true;
		});		
	
		takeasy.win.on('beforeclose', function () {
			app.appOpenNum--;
			app.appIsReady = true;
			app.appWins.pop();

			try {
				AS.ARC.pollingManager.removeRegister(fn.pollingId, fn.newSubscriptionReceiver);
			} catch (e) {
				console.log(e);
			}		
		});		
		takeasy.win.show();
		
		// Get all wins for handling
		this.appWins.push(takeasy.win);
	}
});